#version 330 compatibility




/*
 _______ _________ _______  _______  _ 
(  ____ \\__   __/(  ___  )(  ____ )( )
| (    \/   ) (   | (   ) || (    )|| |
| (_____    | |   | |   | || (____)|| |
(_____  )   | |   | |   | ||  _____)| |
      ) |   | |   | |   | || (      (_)
/\____) |   | |   | (___) || )       _ 
\_______)   )_(   (_______)|/       (_)

Do not modify this code until you have read the LICENSE.txt contained in the root directory of this shaderpack!

*/





in vec4 texcoord;

in vec3 colorSunlight;
in vec3 colorSkylight;
in vec3 colorTorchlight;
in vec3 colorSkyUp;

in vec4 skySHR;
in vec4 skySHG;
in vec4 skySHB;

in vec3 worldLightVector;
in vec3 worldSunVector;

out float timeMidnight;

#include "lib/Uniforms.inc"
#include "lib/Common.inc"



/////////////////////////FUNCTIONS/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////FUNCTIONS/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////








vec2 GetNearFragment(vec2 coord, float depth, out float minDepth)
{
	
	
	vec2 texel = 1.0 / vec2(viewWidth, viewHeight);
	vec4 depthSamples;
	depthSamples.x = texture2D(depthtex1, coord + texel * vec2(1.0, 1.0)).x;
	depthSamples.y = texture2D(depthtex1, coord + texel * vec2(1.0, -1.0)).x;
	depthSamples.z = texture2D(depthtex1, coord + texel * vec2(-1.0, 1.0)).x;
	depthSamples.w = texture2D(depthtex1, coord + texel * vec2(-1.0, -1.0)).x;

	vec2 targetFragment = vec2(0.0, 0.0);

	if (depthSamples.x < depth)
		targetFragment = vec2(1.0, 1.0);
	if (depthSamples.y < depth)
		targetFragment = vec2(1.0, -1.0);
	if (depthSamples.z < depth)
		targetFragment = vec2(-1.0, 1.0);
	if (depthSamples.w < depth)
		targetFragment = vec2(-1.0, -1.0);


	minDepth = min(min(min(depthSamples.x, depthSamples.y), depthSamples.z), depthSamples.w);

	return coord + texel * targetFragment;
}






#include "lib/Materials.inc"




#include "lib/GBufferData.inc"





















int t(float v)
 {
   return int(floor(v));
 }
 int e(int v)
 {
   return v-t(mod(float(v),2.))-0;
 }
 int d(int v)
 {
   return v-t(mod(float(v),2.))-1;
 }
 int d()
 {
   ivec2 v=ivec2(viewWidth,viewHeight);
   int z=v.x*v.y;
   return e(t(floor(pow(float(z),.333333))));
 }
 int e()
 {
   ivec2 v=ivec2(2048,2048);
   int z=v.x*v.y;
   return d(t(floor(pow(float(z),.333333))));
 }
 vec3 v(vec2 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int z=f.x*f.y,y=d();
   ivec2 i=ivec2(v.x*f.x,v.y*f.y);
   float x=float(i.y/y),r=float(int(i.x+mod(f.x*x,y))/y);
   r+=floor(f.x*x/y);
   vec3 s=vec3(0.,0.,r);
   s.x=mod(i.x+mod(f.x*x,y),y);
   s.y=mod(i.y,y);
   s.xyz=floor(s.xyz);
   s/=y;
   s.xyz=s.xzy;
   return s;
 }
 vec2 f(vec3 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int z=d();
   vec3 i=v.xzy*z;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 r;
   r.x=mod(i.x+x*z,f.x);
   float c=i.x+x*z;
   r.y=i.y+floor(c/f.x)*z;
   r+=.5;
   r/=f;
   return r;
 }
 vec3 x(vec2 v)
 {
   vec2 f=v;
   f.xy/=.5;
   ivec2 s=ivec2(2048,2048);
   int z=s.x*s.y,y=e();
   ivec2 i=ivec2(f.x*s.x,f.y*s.y);
   float x=float(i.y/y),r=float(int(i.x+mod(s.x*x,y))/y);
   r+=floor(s.x*x/y);
   vec3 n=vec3(0.,0.,r);
   n.x=mod(i.x+mod(s.x*x,y),y);
   n.y=mod(i.y,y);
   n.xyz=floor(n.xyz);
   n/=y;
   n.xyz=n.xzy;
   return n;
 }
 vec2 d(vec3 v,int y)
 {
   v=clamp(v,vec3(0.),vec3(1.));
   ivec2 f=ivec2(2048,2048);
   vec3 i=v.xzy*y;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 r;
   r.x=mod(i.x+x*y,f.x);
   float z=i.x+x*y;
   r.y=i.y+floor(z/f.x)*y;
   r+=.5;
   r/=f;
   r.xy*=.5;
   return r;
 }
 vec3 e(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v=clamp(v,vec3(0.),vec3(1.)),v;
 }
 vec3 f(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v;
 }
 vec3 s(vec3 v)
 {
   int f=e();
   v=v-vec3(.5);
   v*=f;
   return v;
 }
 vec3 w(vec3 v)
 {
   int z=d();
   v*=1./z;
   v=v+vec3(.5);
   v=clamp(v,vec3(0.),vec3(1.));
   return v;
 }
 vec3 r(vec3 v)
 {
   int f=d();
   v=v-vec3(.5);
   v*=f;
   return v;
 }
 vec3 n(vec3 v)
 {
   vec4 f=vec4(v,1.);
   f.xyz+=1.;
   f.xyz-=Fract01(cameraPosition.xyz+.5);
   f=shadowModelView*f;
   f=shadowProjection*f;
   f/=f.w;
   float x=sqrt(f.x*f.x+f.y*f.y),y=1.f-SHADOW_MAP_BIAS+x*SHADOW_MAP_BIAS;
   f.xy*=.95f/y;
   f.z=mix(f.z,.5,.8);
   f=f*.5f+.5f;
   f.xy*=.5;
   f.xy+=.5;
   return f.xyz;
 }struct zNBzKgUtly{float AvJUxmdirG;float WCbWyvymZz;float ABrGOYvmhP;float dyVwWpTUTv;vec3 kVdfXZomUb;};
 vec4 h(zNBzKgUtly v)
 {
   vec4 f;
   v.kVdfXZomUb=max(vec3(0.),v.kVdfXZomUb);
   f.x=v.AvJUxmdirG;
   v.kVdfXZomUb=pow(v.kVdfXZomUb,vec3(.25));
   f.y=PackTwo16BitTo32Bit(v.kVdfXZomUb.x,v.ABrGOYvmhP);
   f.z=PackTwo16BitTo32Bit(v.kVdfXZomUb.y,v.dyVwWpTUTv);
   f.w=PackTwo16BitTo32Bit(v.kVdfXZomUb.z,v.WCbWyvymZz);
   return f;
 }
 zNBzKgUtly p(vec4 v)
 {
   zNBzKgUtly f;
   vec2 i=UnpackTwo16BitFrom32Bit(v.y),s=UnpackTwo16BitFrom32Bit(v.z),n=UnpackTwo16BitFrom32Bit(v.w);
   f.AvJUxmdirG=v.x;
   f.ABrGOYvmhP=i.y;
   f.dyVwWpTUTv=s.y;
   f.WCbWyvymZz=n.y;
   f.kVdfXZomUb=pow(vec3(i.x,s.x,n.x),vec3(4.));
   return f;
 }
 zNBzKgUtly m(vec2 v)
 {
   vec2 z=1./vec2(viewWidth,viewHeight),y=vec2(viewWidth,viewHeight);
   v=(floor(v*y)+.5)*z;
   return p(texture2DLod(colortex5,v,0));
 }
 float h(float v,float y)
 {
   float z=1.;
   #ifdef FULL_RT_REFLECTIONS
   z=clamp(pow(v,.125)+y,0.,1.);
   #else
   z=clamp(v*10.-7.,0.,1.);
   #endif
   return z;
 }
 void d(inout float v,inout float f,float x,float y,vec3 i,float z)
 {
   v*=mix(2.,2.4,y);
   float c=dot(i,vec3(1.));
   f*=1.-pow(y,1.);
   f/=x*.1+2e-06;
   f*=4.;
   f*=.1;
   float r=x/(c+1e-07)*.2+4e-08;
   r=min(r,1.);
   r=mix(r,1.,pow(y,.25));
   if(z<.12)
     f=0.;
 }
 float d(vec3 v,vec3 y,float f)
 {
   float z=dot(abs(v-y),vec3(.3333));
   z*=f;
   z*=.18;
   return z;
 }
 void e(inout vec3 v,vec2 y,vec3 z)
 {}
 float m(float v,float y)
 {
   return v/(y*20.01+1.);
 }struct Ray{vec3 dir;vec3 origin;};struct BBRay{vec3 origin;vec3 direction;vec3 inv_direction;ivec3 sign;};
 BBRay n(vec3 v,vec3 y)
 {
   vec3 f=vec3(1.)/y;
   return BBRay(v,y,f,ivec3(f.x<0?1:0,f.y<0?1:0,f.z<0?1:0));
 }
 void d(in BBRay v,in vec3 f[2],out float i,out float y)
 {
   float z,r,x,n;
   i=(f[v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   y=(f[1-v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   z=(f[v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   r=(f[1-v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   x=(f[v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   n=(f[1-v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   i=max(max(i,z),x);
   y=min(min(y,r),n);
 }
 vec2 i(inout float v)
 {
   return fract(sin(vec2(v+=.1,v+=.1))*vec2(43758.5,22578.1));
 }
 vec3 c(vec2 v)
 {
   vec2 f=vec2(v.xy*vec2(viewWidth,viewHeight))/64.;
   const vec2 s[16]=vec2[16](vec2(-1,-1),vec2(0,-.333333),vec2(-.5,.333333),vec2(.5,-.777778),vec2(-.75,-.111111),vec2(.25,.555556),vec2(-.25,-.555556),vec2(.75,.111111),vec2(-.875,.777778),vec2(.125,-.925926),vec2(-.375,-.259259),vec2(.625,.407407),vec2(-.625,-.703704),vec2(.375,-.037037),vec2(-.125,.62963),vec2(.875,-.481482));
   if(v.x<2./viewWidth||v.x>1.-2./viewWidth||v.y<2./viewHeight||v.y>1.-2./viewHeight)
     ;
   else
      f+=s[int(mod(frameCounter,4))]*.5;
   f=(floor(f*64.)+.5)/64.;
   vec3 z=texture2D(noisetex,f).xyz;
   return z;
 }
 vec3 c(vec3 v,inout float y,int z)
 {
   vec2 f=c(texcoord.xy+vec2(y+=.1,y+=.1)).xy;
   f=fract(f+i(y)*.1);
   float x=6.28319*f.x,r=sqrt(f.y);
   vec3 s=normalize(cross(v,vec3(0.,1.,1.))),n=cross(v,s),t=s*cos(x)*r+n*sin(x)*r+v.xyz*sqrt(1.-f.y);
   return t;
 }
 float c(vec3 v,vec3 y,vec3 z,int f)
 {
   vec3 i=s(v),d=n(i+y*.99);
   float x=.5,r=shadow2DLod(shadowtex0,vec3(d.xy,d.z-.0006*x),3).x;
   r*=saturate(dot(worldLightVector,y));
   return r;
 }
 float e(vec3 v,vec3 y,vec3 z,int f)
 {
   if(rainStrength>.99)
     return 0.f;
   vec3 i=n(v);
   float x=.5,r=shadow2DLod(shadowtex0,vec3(i.xy,i.z-.0006*x),0).x;
   r*=saturate(dot(worldLightVector,y));
   return r*(1.-rainStrength);
 }
 vec3 c()
 {
   vec3 v=cameraPosition.xyz+.5-Fract01(cameraPosition.xyz+.5),y=previousCameraPosition+.5-Fract01(previousCameraPosition+.5);
   return v-y;
 }
 vec3 c(vec3 v,vec3 y)
 {
   vec2 z=f(w(s(v)+y+1.));
   vec3 x=m(z).kVdfXZomUb;
   return x;
 }
 vec3 f()
 {
   vec2 y=f(v(texcoord.xy)+c()/d());
   vec3 z=m(y).kVdfXZomUb;
   return z;
 }
 bool i(ivec3 v,BBRay f)
 {
   vec3 z=vec3(v),y=vec3(v)+1.,x=mix(z,y,vec3(.5));
   float i=mix(.25,0.,saturate(distance(f.origin,x)*.5-1.));
   vec3 r[2]=vec3[2](mix(z,y,vec3(i)),mix(z,y,vec3(1.-i)));
   float s,n;
   d(f,r,s,n);
   return s<=n;
 }
 vec3 f(float v,float f,float y,vec3 z)
 {
   vec3 r;
   r.x=y*cos(v);
   r.y=y*sin(v);
   r.z=f;
   vec3 x=abs(z.y)<.999?vec3(0,0,1):vec3(1,0,0),i=normalize(cross(z,vec3(0.,1.,1.))),n=cross(i,z);
   return i*r.x+n*r.y+z*r.z;
 }
 vec3 f(vec2 v,float y,vec3 z)
 {
   float i=2*3.14159*v.x,x=sqrt((1-v.y)/(1+(y*y-1)*v.y)),r=sqrt(1-x*x);
   return f(i,x,r,z);
 }
 float l(float v)
 {
   return 2./(v*v+1e-07)-2.;
 }
 vec3 h(in vec2 v,in float y,in vec3 z)
 {
   float i=l(y),x=2*3.14159*v.x,r=pow(v.y,1.f/(i+1.f)),s=sqrt(1-r*r);
   return f(x,r,s,z);
 }
 float l(float v,float y)
 {
   return 1./(v*(1.-y)+y);
 }
 void p(inout vec3 v,in vec3 f)
 {
   vec3 y=normalize(f.xyz),i=v;
   float z=dot(i,y);
   i=normalize(v-y*saturate(z)*.5);
   v=i;
 }
 vec4 B(in vec2 v)
 {
   float z=GetDepth(v);
   vec4 f=gbufferProjectionInverse*vec4(v.x*2.f-1.f,v.y*2.f-1.f,2.f*z-1.f,1.f);
   f/=f.w;
   return f;
 }
 vec4 B(in vec2 v,in float y)
 {
   vec4 f=gbufferProjectionInverse*vec4(v.x*2.f-1.f,v.y*2.f-1.f,2.f*y-1.f,1.f);
   f/=f.w;
   return f;
 }
 void B(inout vec3 v,in vec3 y,in vec3 z,vec3 f,float i)
 {
   float x=length(y);
   #ifdef FADE_TO_ATMOSPHERE
   float r=length(y)/far;
   r=pow(r,6.)*.07+pow(r,2.)*.003;
   #else
   float s=length(y)/300.;
   s=pow(s,3.)*.002;
   #endif
   s*=pow(eyeBrightnessSmooth.y/240.f,6.f);
   s=clamp(s,0.,.03);
   s/=saturate(f.y)*2.+1.;
   vec3 n=vec3(.2,.45,1.);
   v*=exp(-s*n*100.67);
   v+=AtmosphericScattering(normalize(f),worldSunVector,1.,s)*.9*mix(i,1.,.5)*mix(1.,.35,wetness)*.001;
 }
 void c(inout vec3 v,in vec3 y,in vec3 z,vec3 f,float x)
 {
   float r=length(y);
   r*=pow(eyeBrightnessSmooth.y/240.f,6.f);
   r*=rainStrength;
   float i=pow(exp(-r*1e-05),4.);
   i=max(i,.5);
   vec3 s=vec3(dot(colorSkyUp,vec3(1.)))*.05;
   v=mix(s,v,vec3(i));
 }
 vec4 B(float v,float f,vec3 i,vec3 y,vec3 z,vec3 x,vec3 r,float s,float t)
 {
   float b=1.;
   #ifdef SUNLIGHT_LEAK_FIX
   b=saturate(t*100.);
   #endif
   v=max(v-.05,0.);
   f=0.;
   float m=v*v,w=fract(frameCounter*.0123456);
   vec3 p=c(texcoord.xy).xyz*.99+.005,G=c(texcoord.xy+.1).xyz,a=reflect(r,h(p.xy,m,z));
   if(dot(a,z)<0.)
     a=reflect(a,z);
   #ifdef REFLECTION_SCREEN_SPACE_TRACING
   bool B=false;
   {
     const int k=32;
     vec2 o=texcoord.xy;
     vec3 g=y.xyz,P=normalize((gbufferModelView*vec4(a.xyz,0.)).xyz);
     float R=0.;
     vec3 T=y.xyz;
     float F=.05/saturate(dot(-r,z)+.001),U=F*2.,S=1.,M=0.;
     for(int D=0;D<k;D++)
       {
         float A=float(D),u=(A+.5)/float(k);
         vec3 C=P.xyz*F*(.1+length(T)*.1)*S;
         float W=U*(length(T)*.1);
         T+=C;
         vec2 L=ProjectBack(T).xy;
         vec3 N=GetViewPosition(L.xy,GetDepth(L.xy)).xyz;
         float I=length(T)-length(N)-.02;
         if(T.z>0.)
           {
             break;
           }
         if(I>0.&&I<W&&L.x>0.&&L.x<1.&&L.y>0.&&L.y<1.)
           {
             T-=C;
             S*=.5;
             M+=1.;
             if(M>2.)
               {
                 B=true;
                 o=L.xy;
                 g=N.xyz;
                 R=distance(T,y.xyz)*.4;
                 break;
               }
           }
       }
     vec3 D=(gbufferModelViewInverse*vec4(g,1.)).xyz;
     D+=Fract01(cameraPosition.xyz+.5)+.5;
     if(length(D)>far)
       B=false;
     if(B)
       {
         o.xy=floor(o.xy*vec2(viewWidth,viewHeight)+.5)/vec2(viewWidth,viewHeight);
         vec3 A=pow(texture2DLod(colortex3,o.xy,0).xyz,vec3(2.2));
         return vec4(A*100.,saturate(R/4.));
       }
   }
   #endif
   int T=e(),o=d();
   vec3 g=i+z*(.001+s*.1);
   g+=Fract01(cameraPosition.xyz+.5);
   vec3 A=g;
   g=e(g,T);
   Ray L;
   L.origin=g*T-vec3(1.,1.,1.);
   L.dir=a;
   BBRay D=n(L.origin,L.dir);
   vec3 S=vec3(1.),M=vec3(0.);
   float R=0.,N=0.;
   for(int F=0;F<1;F++)
     {
       vec3 P=vec3(floor(L.origin)),k=abs(vec3(length(L.dir))/(L.dir+.0001)),C=sign(L.dir),u=(sign(L.dir)*(P-L.origin)+sign(L.dir)*.5+.5)*k,U;
       vec4 I=vec4(0.);
       vec3 W=vec3(0.);
       float V=.5;
       for(int E=0;E<REFLECTION_TRACE_LENGTH;E++)
         {
           W=P/float(T);
           vec2 O=d(W,T);
           I=texture2DLod(shadowcolor,O,0);
           R=I.w*255.;
           float H=1.-step(.5,abs(R-GI_ID_NONBLOCK_LIGHT));
           vec3 X=I.xyz;
           float Z=dot(P+.5-L.origin,P+.5-L.origin),Y=saturate(pow(saturate(dot(L.dir,normalize(P+.5-L.origin))),56.*Z)*5.-1.)*5.;
           M+=GI_NONBLOCK_LIGHT_BRIGHTNESS*X*H*V*.5*Y;
           if(R<GI_ID_FIRST_NONSOLID&&E!=0)
             {
               break;
             }
           U=step(u.xyz,u.yzx)*step(u.xyz,u.zxy);
           u+=U*k;
           P+=U*C;
           V=1.;
         }
       if(I.w*255.<1.f||I.w*255.>254.f)
         {
           vec3 E=SkyShading(L.dir,worldSunVector,rainStrength);
           E=DoNightEyeAtNight(E*12.,timeMidnight)*.083333;
           M+=E*.1;
           N=1000.;
           break;
         }
       vec3 E=-(U*C),O[2]=vec3[2](P,P+1.);
       float Y,H;
       d(D,O,Y,H);
       N=Y;
       vec3 X=mod(L.origin+L.dir*Y,vec3(1.))-.5;
       vec2 Z=vec2(0.);
       Z+=vec2(X.z*C.x,-X.y)*U.x;
       Z+=vec2(X.x,-X.z*C.y)*U.y;
       Z+=vec2(-X.x*C.z,-X.y)*U.z;
       vec3 K=(L.origin+L.dir*Y)/float(T);
       vec2 q=textureSize(colortex0,0);
       vec4 j=texture2DLod(shadowcolor1,d(W,T),0);
       vec2 J=j.xy;
       J=(floor(J*q/TEXTURE_RESOLUTION)+.5)/(q/TEXTURE_RESOLUTION);
       vec2 Q=J+Z.xy*(TEXTURE_RESOLUTION/q);
       vec3 ab=pow(texture2D(colortex0,Q).xyz,vec3(2.2));
       ab*=mix(vec3(1.),I.xyz/(j.w+1e-05),vec3(j.z));
       if(R<GI_ID_FIRST_NONSOLID)
         {
           vec3 ac=saturate(I.xyz);
           S*=ab;
         }
       if(abs(R-GI_ID_BLOCK_LIGHT)<.1)
         M+=.09*S*GI_LIGHT_BLOCK_INTENSITY;
       vec3 ad=vec3(0.),ae=vec3(0.);
       if(abs(E.x)>.5)
         ad=vec3(0.,1.,0.),ae=vec3(0.,0.,1.);
       if(abs(E.y)>.5)
         ad=vec3(1.,0.,0.),ae=vec3(0.,0.,1.);
       if(abs(E.z)>.5)
         ad=vec3(1.,0.,0.),ae=vec3(0.,1.,0.);
       ad*=1.;
       ae*=1.;
       vec3 af=c(W,E),ag=af,ah=saturate(af*100000.),ai=c(W+ad/float(T),E);
       ag+=ai;
       ah+=saturate(ai*100000.);
       vec3 aj=c(W-ad/float(T),E);
       ag+=aj;
       ah+=saturate(aj*100000.);
       vec3 ak=c(W+ae/float(T),E);
       ag+=ak;
       ah+=saturate(ak*100000.);
       vec3 al=c(W-ae/float(T),E);
       ag+=al;
       ah+=saturate(al*100000.);
       ag/=ah+vec3(.0001);
       M+=ag*1.5*S;
       const float am=2.4;
       M+=e(A+L.dir*Y-1.,E,a,T)*S*am*colorSunlight*b;
     }
   M*=1.;
   vec3 E=normalize(y.xyz)*(length(y.xyz)+N);
   c(M,E,normalize(y.xyz),normalize(i.xyz),1.);
   vec3 P=normalize(-r+a);
   float W=saturate(dot(z,a)),u=saturate(dot(z,-r)),I=saturate(dot(z,P)),O=saturate(dot(a,P)),U=f*.98+.02,Y=pow(1.-O,5.),k=U+(1.-U)*Y,H=m/2.,C=l(W,H)*l(u+.8,H);
   N*=saturate(dot(-r,z))*2.;
   return vec4(M,saturate(N/4.));
 }
 vec4 G(float v)
 {
   float f=v*v,y=f*v;
   vec4 r;
   r.x=-y+3*f-3*v+1;
   r.y=3*y-6*f+4;
   r.z=-3*y+3*f+3*v+1;
   r.w=y;
   return r/6.f;
 }
 vec4 G(in sampler2D v,in vec2 f)
 {
   vec2 y=vec2(viewWidth,viewHeight);
   f*=y;
   f-=.5;
   float z=fract(f.x),i=fract(f.y);
   f.x-=z;
   f.y-=i;
   vec4 s=G(z),r=G(i),a=vec4(f.x-.5,f.x+1.5,f.y-.5,f.y+1.5),n=vec4(s.x+s.y,s.z+s.w,r.x+r.y,r.z+r.w),L=a+vec4(s.y,s.w,r.y,r.w)/n,x=texture2DLod(v,vec2(L.x,L.z)/y,0),t=texture2DLod(v,vec2(L.y,L.z)/y,0),E=texture2DLod(v,vec2(L.x,L.w)/y,0),c=texture2DLod(v,vec2(L.y,L.w)/y,0);
   float T=n.x/(n.x+n.y),w=n.z/(n.z+n.w);
   return mix(mix(c,E,T),mix(t,x,T),w);
 }
 bool r(vec3 v,vec3 y)
 {
   vec3 z=normalize(cross(dFdx(v),dFdy(v))),f=normalize(y-v),i=normalize(f);
   return distance(v,y)<.05;
 }
 vec3 o(vec2 v)
 {
   vec2 y=vec2(viewWidth,viewHeight),f=1./y,i=v*y,z=floor(i-.5)+.5,x=i-z,r=x*x,a=x*r;
   float s=.5;
   vec2 L=-s*a+2.*s*r-s*x,n=(2.-s)*a-(3.-s)*r+1.,E=-(2.-s)*a+(3.-2.*s)*r+s*x,d=s*a-s*r,T=n+E,t=f*(z+E/T);
   vec3 c=texture2DLod(colortex4,vec2(t.x,t.y),0).xyz;
   vec2 o=f*(z-1.),u=f*(z+2.);
   vec4 I=vec4(texture2DLod(colortex4,vec2(t.x,o.y),0).xyz,1.)*(T.x*L.y)+vec4(texture2DLod(colortex4,vec2(o.x,t.y),0).xyz,1.)*(L.x*T.y)+vec4(c,1.)*(T.x*T.y)+vec4(texture2DLod(colortex4,vec2(u.x,t.y),0).xyz,1.)*(d.x*T.y)+vec4(texture2DLod(colortex4,vec2(t.x,u.y),0).xyz,1.)*(T.x*d.y);
   return max(vec3(0.),I.xyz*(1./I.w));
 }
 void main()
 {
   GBufferData v=GetGBufferData();
   GBufferDataTransparent f=GetGBufferDataTransparent();
   MaterialMask i=CalculateMasks(v.materialID),y=CalculateMasks(f.materialID);
   bool z=f.depth<v.depth;
   if(z)
     v.depth=f.depth,v.normal=f.normal,v.smoothness=f.smoothness,v.metalness=0.,v.mcLightmap=f.mcLightmap,y.sky=0.;
   vec4 r=GetViewPosition(texcoord.xy,v.depth),n=gbufferModelViewInverse*vec4(r.xyz,1.),L=gbufferModelViewInverse*vec4(r.xyz,0.);
   vec3 x=normalize(r.xyz),s=normalize(L.xyz),a=normalize((gbufferModelViewInverse*vec4(v.normal,0.)).xyz),E=normalize((gbufferModelViewInverse*vec4(v.geoNormal,0.)).xyz);
   float c=length(r.xyz);
   vec4 t=vec4(0.);
   float d=h(v.smoothness,v.metalness);
   if(d>.0001&&y.sky<.5)
     t=B(1.-v.smoothness,v.metalness,n.xyz,r.xyz,a.xyz,E,s.xyz,i.leaves,v.mcLightmap.y);
   vec4 T=texture2DLod(colortex3,texcoord.xy,0);
   T.xyz=pow(T.xyz,vec3(2.2));
   if(z)
     {
       vec3 o=GetViewPosition(texcoord.xy,texture2DLod(depthtex1,texcoord.xy,0).x).xyz;
       float m=length(o.xyz),M=m-c;
       vec3 I=f.normal-f.geoNormal*1.05;
       float k=saturate(M*.5);
       vec2 u=texcoord.xy+I.xy/(c+.2)*k;
       T.xyz=pow(texture2DLod(colortex3,u.xy,0).xyz,vec3(2.2));
       o=GetViewPosition(u.xy,texture2DLod(depthtex1,u.xy,0).x).xyz;
       r=GetViewPosition(u.xy,texture2DLod(depthtex0,u.xy,0).x);
       m=length(o.xyz);
       c=length(r.xyz);
       M=m-c;
       if(y.water>.5)
         {
           T.xyz*=exp(vec3(1.,.4,.1)*-(M+2.1)*.2);
           vec3 g=vec3(.2,.8,.8)*.0001;
           g=(g*colorSunlight*.5+g*colorSkylight)*f.mcLightmap.y;
           T.xyz=mix(g,T.xyz,vec3(exp(-M*.2)));
           t.xyz*=.8;
         }
       if(y.stainedGlass>.5)
         {
           vec3 w=normalize(f.albedo.xyz+.0001)*pow(length(f.albedo.xyz),.5);
           T.xyz*=mix(vec3(1.),w,vec3(pow(f.albedo.w,.2)));
           T.xyz*=mix(vec3(1.),w,vec3(pow(f.albedo.w,.2)));
         }
     }
   T.xyz=pow(T.xyz,vec3(1./2.2));
   t.xyz=saturate(t.xyz);
   gl_FragData[0]=texture2DLod(colortex0,texcoord.xy,0);
   gl_FragData[1]=vec4(T.xyz,v.smoothness);
   gl_FragData[2]=t;
 };

/* DRAWBUFFERS:036 */