#version 330 compatibility




/*
 _______ _________ _______  _______  _ 
(  ____ \\__   __/(  ___  )(  ____ )( )
| (    \/   ) (   | (   ) || (    )|| |
| (_____    | |   | |   | || (____)|| |
(_____  )   | |   | |   | ||  _____)| |
      ) |   | |   | |   | || (      (_)
/\____) |   | |   | (___) || )       _ 
\_______)   )_(   (_______)|/       (_)

Do not modify this code until you have read the LICENSE.txt contained in the root directory of this shaderpack!

*/


#include "lib/Uniforms.inc"
#include "lib/Common.inc"


const bool colortex6MipmapEnabled = false;


in vec4 texcoord;
in vec3 lightVector;

in float timeSunriseSunset;
in float timeNoon;
in float timeMidnight;
in float timeSkyDark;

in vec3 colorSunlight;
in vec3 colorSkylight;
in vec3 colorSunglow;
in vec3 colorBouncedSunlight;
in vec3 colorScatteredSunlight;
in vec3 colorTorchlight;
in vec3 colorWaterMurk;
in vec3 colorWaterBlue;
in vec3 colorSkyTint;

in vec3 worldSunVector;


in vec3 upVector;
in vec3 skyUpColor;

#include "lib/GBufferData.inc"


// vec4 GetViewPosition(in vec2 coord, in float depth) 
// {	
// 	vec4 tcoord = vec4(coord.xy, 0.0, 0.0);

// 	vec4 fragposition = gbufferProjectionInverse * vec4(tcoord.s * 2.0f - 1.0f, tcoord.t * 2.0f - 1.0f, 2.0f * depth - 1.0f, 1.0f);
// 		 fragposition /= fragposition.w;

	
// 	return fragposition;
// }





#include "lib/Materials.inc"






int v(float v)
 {
   return int(floor(v));
 }
 int t(int f)
 {
   return f-v(mod(float(f),2.))-0;
 }
 int d(int f)
 {
   return f-v(mod(float(f),2.))-1;
 }
 int d()
 {
   ivec2 m=ivec2(viewWidth,viewHeight);
   int f=m.x*m.y;
   return t(v(floor(pow(float(f),.333333))));
 }
 int t()
 {
   ivec2 m=ivec2(2048,2048);
   int f=m.x*m.y;
   return d(v(floor(pow(float(f),.333333))));
 }
 vec3 w(vec2 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int z=f.x*f.y,s=d();
   ivec2 i=ivec2(v.x*f.x,v.y*f.y);
   float y=float(i.y/s),x=float(int(i.x+mod(f.x*y,s))/s);
   x+=floor(f.x*y/s);
   vec3 m=vec3(0.,0.,x);
   m.x=mod(i.x+mod(f.x*y,s),s);
   m.y=mod(i.y,s);
   m.xyz=floor(m.xyz);
   m/=s;
   m.xyz=m.xzy;
   return m;
 }
 vec2 e(vec3 f)
 {
   ivec2 v=ivec2(viewWidth,viewHeight);
   int z=d();
   vec3 i=f.xzy*z;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 m;
   m.x=mod(i.x+x*z,v.x);
   float y=i.x+x*z;
   m.y=i.y+floor(y/v.x)*z;
   m+=.5;
   m/=v;
   return m;
 }
 vec3 r(vec2 v)
 {
   vec2 f=v;
   f.xy/=.5;
   ivec2 m=ivec2(2048,2048);
   int z=m.x*m.y,s=t();
   ivec2 i=ivec2(f.x*m.x,f.y*m.y);
   float y=float(i.y/s),x=float(int(i.x+mod(m.x*y,s))/s);
   x+=floor(m.x*y/s);
   vec3 r=vec3(0.,0.,x);
   r.x=mod(i.x+mod(m.x*y,s),s);
   r.y=mod(i.y,s);
   r.xyz=floor(r.xyz);
   r/=s;
   r.xyz=r.xzy;
   return r;
 }
 vec2 d(vec3 v,int z)
 {
   v=clamp(v,vec3(0.),vec3(1.));
   ivec2 f=ivec2(2048,2048);
   vec3 i=v.xzy*z;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 m;
   m.x=mod(i.x+x*z,f.x);
   float y=i.x+x*z;
   m.y=i.y+floor(y/f.x)*z;
   m+=.5;
   m/=f;
   m.xy*=.5;
   return m;
 }
 vec3 e(vec3 v,int z)
 {
   return v*=1./z,v=v+vec3(.5),v=clamp(v,vec3(0.),vec3(1.)),v;
 }
 vec3 r(vec3 v,int z)
 {
   return v*=1./z,v=v+vec3(.5),v;
 }
 vec3 p(vec3 v)
 {
   int m=t();
   v=v-vec3(.5);
   v*=m;
   return v;
 }
 vec3 f(vec3 v)
 {
   int z=d();
   v*=1./z;
   v=v+vec3(.5);
   v=clamp(v,vec3(0.),vec3(1.));
   return v;
 }
 vec3 x(vec3 v)
 {
   int m=d();
   v=v-vec3(.5);
   v*=m;
   return v;
 }
 vec3 s(vec3 v)
 {
   vec4 m=vec4(v,1.);
   m.xyz+=1.;
   m.xyz-=Fract01(cameraPosition.xyz+.5);
   m=shadowModelView*m;
   m=shadowProjection*m;
   m/=m.w;
   float x=sqrt(m.x*m.x+m.y*m.y),f=1.f-SHADOW_MAP_BIAS+x*SHADOW_MAP_BIAS;
   m.xy*=.95f/f;
   m.z=mix(m.z,.5,.8);
   m=m*.5f+.5f;
   m.xy*=.5;
   m.xy+=.5;
   return m.xyz;
 }struct zNBzKgUtly{float AvJUxmdirG;float WCbWyvymZz;float ABrGOYvmhP;float dyVwWpTUTv;vec3 kVdfXZomUb;};
 vec4 h(zNBzKgUtly v)
 {
   vec4 m;
   v.kVdfXZomUb=max(vec3(0.),v.kVdfXZomUb);
   m.x=v.AvJUxmdirG;
   v.kVdfXZomUb=pow(v.kVdfXZomUb,vec3(.25));
   m.y=PackTwo16BitTo32Bit(v.kVdfXZomUb.x,v.ABrGOYvmhP);
   m.z=PackTwo16BitTo32Bit(v.kVdfXZomUb.y,v.dyVwWpTUTv);
   m.w=PackTwo16BitTo32Bit(v.kVdfXZomUb.z,v.WCbWyvymZz);
   return m;
 }
 zNBzKgUtly n(vec4 v)
 {
   zNBzKgUtly m;
   vec2 f=UnpackTwo16BitFrom32Bit(v.y),i=UnpackTwo16BitFrom32Bit(v.z),s=UnpackTwo16BitFrom32Bit(v.w);
   m.AvJUxmdirG=v.x;
   m.ABrGOYvmhP=f.y;
   m.dyVwWpTUTv=i.y;
   m.WCbWyvymZz=s.y;
   m.kVdfXZomUb=pow(vec3(f.x,i.x,s.x),vec3(4.));
   return m;
 }
 zNBzKgUtly a(vec2 v)
 {
   vec2 m=1./vec2(viewWidth,viewHeight),f=vec2(viewWidth,viewHeight);
   v=(floor(v*f)+.5)*m;
   return n(texture2DLod(colortex5,v,0));
 }
 float a(float v,float z)
 {
   float m=1.;
   #ifdef FULL_RT_REFLECTIONS
   m=clamp(pow(v,.125)+z,0.,1.);
   #else
   m=clamp(v*10.-7.,0.,1.);
   #endif
   return m;
 }
 void a(inout float v,inout float m,float y,float f,vec3 z,float i)
 {
   v*=mix(2.,2.4,f);
   float x=dot(z,vec3(1.));
   m*=1.-pow(f,1.);
   m/=y*.1+2e-06;
   m*=4.;
   m*=.1;
   float r=y/(x+1e-07)*.2+4e-08;
   r=min(r,1.);
   r=mix(r,1.,pow(f,.25));
   if(i<.12)
     m=0.;
 }
 float a(vec3 v,vec3 z,float m)
 {
   float f=dot(abs(v-z),vec3(.3333));
   f*=m;
   f*=.18;
   return f;
 }
 void d(inout vec3 v,vec2 z,vec3 f)
 {}
 float f(float v,float f)
 {
   return v/(f*20.01+1.);
 }
 float h(float v,float z)
 {
   return exp(-pow(v/(.9*z),2.));
 }
 float n(vec3 v,vec3 z)
 {
   return dot(abs(v-z),vec3(.3333));
 }
 vec3 m(vec2 v)
 {
   vec2 f=vec2(v.xy*vec2(viewWidth,viewHeight))/64.;
   const vec2 m[16]=vec2[16](vec2(-1,-1),vec2(0,-.333333),vec2(-.5,.333333),vec2(.5,-.777778),vec2(-.75,-.111111),vec2(.25,.555556),vec2(-.25,-.555556),vec2(.75,.111111),vec2(-.875,.777778),vec2(.125,-.925926),vec2(-.375,-.259259),vec2(.625,.407407),vec2(-.625,-.703704),vec2(.375,-.037037),vec2(-.125,.62963),vec2(.875,-.481482));
   if(v.x<2./viewWidth||v.x>1.-2./viewWidth||v.y<2./viewHeight||v.y>1.-2./viewHeight)
     ;
   f=(floor(f*64.)+.5)/64.;
   vec3 i=texture2D(noisetex,f).xyz,s=vec3(sqrt(.2),sqrt(2.),1.61803);
   i=mod(i+vec3(s)*mod(frameCounter,64),vec3(1.));
   return i;
 }
 vec3 a(float v,float m,float f,vec3 z)
 {
   vec3 i;
   i.x=f*cos(v);
   i.y=f*sin(v);
   i.z=m;
   vec3 x=abs(z.y)<.999?vec3(0,0,1):vec3(1,0,0),y=normalize(cross(z,vec3(0.,1.,1.))),s=cross(y,z);
   return y*i.x+s*i.y+z*i.z;
 }
 vec3 e(vec2 v,float f,vec3 z)
 {
   float m=2*3.14159*v.x,s=sqrt((1-v.y)/(1+(f*f-1)*v.y)),y=sqrt(1-s*s);
   return a(m,s,y,z);
 }
 float i(float v)
 {
   return 2./(v*v+1e-07)-2.;
 }
 vec3 f(in vec2 v,in float f,in vec3 z)
 {
   float m=i(f),s=2*3.14159*v.x,y=pow(v.y,1.f/(m+1.f)),x=sqrt(1-y*y);
   return a(s,y,x,z);
 }
 float A(vec2 v)
 {
   return texture2DLod(colortex3,v,0).w;
 }
 vec4 A(sampler2D v,float z,bool s,float y,float i,float x,float t)
 {
   GBufferData p=GetGBufferData();
   GBufferDataTransparent r=GetGBufferDataTransparent();
   bool d=r.depth<p.depth;
   if(d)
     p.normal=r.normal,p.smoothness=r.smoothness,p.metalness=0.,p.mcLightmap=r.mcLightmap,p.depth=r.depth;
   vec4 c=GetViewPosition(texcoord.xy,p.depth),b=gbufferModelViewInverse*vec4(c.xyz,1.),h=gbufferModelViewInverse*vec4(c.xyz,0.);
   vec3 w=normalize(c.xyz),l=normalize(h.xyz),G=normalize((gbufferModelViewInverse*vec4(p.normal,0.)).xyz);
   float e=ExpToLinearDepth(p.depth),g=1.-p.smoothness,P=g*g,o=a(p.smoothness,p.metalness);
   int F=0;
   vec4 U=texture2DLod(colortex6,texcoord.xy,F);
   float W=Luminance(U.xyz);
   if(o<.001)
     return U;
   float k=z;
   k*=min(P*15.,1.1);
   k*=mix(U.w,1.,t);
   vec2 D=vec2(0.);
   if(s)
     {
       vec2 E=m(texcoord.xy).xy*.99+.005;
       D=E-.5;
     }
   float E=0.,S=1.1,u=f(y*2.,p.totalTexGrad)/(P+.0001),B=f(i,p.totalTexGrad);
   vec4 L=vec4(0.),M=vec4(0.);
   float C=0.;
   vec4 T=vec4(vec3(x),1.);
   T.xyz*=U.w*.95+.05;
   float V=p.smoothness;
   int H=0;
   for(int Z=-1;Z<=1;Z++)
     {
       for(int I=-1;I<=1;I++)
         {
           vec2 X=(vec2(Z,I)+D)/vec2(viewWidth,viewHeight)*k,O=texcoord.xy+X.xy;
           float N=length(X*vec2(viewWidth,viewHeight));
           O=clamp(O,4./vec2(viewWidth,viewHeight),1.-4./vec2(viewWidth,viewHeight));
           vec4 q=texture2DLod(colortex6,O,F);
           vec3 K=GetNormals(O);
           float Y=GetDepthLinear(O),R=pow(saturate(dot(p.normal,K)),u),J=exp(-(abs(Y-e)*S)),j=exp(-(n(q.xyz,U.xyz)*E)),Q=exp(-abs(V-A(O))*B),ab=R*J*j*Q;
           L+=vec4(pow(length(q.xyz),T.x)*normalize(q.xyz+1e-05),q.w)*ab;
           C+=ab;
           M+=q;
           H++;
         }
     }
   L/=C+.0001;
   L.xyz=pow(length(L.xyz),1./T.x)*normalize(L.xyz+1e-06);
   vec4 q=L;
   if(C<.001)
     q=U;
   return q;
 }
 float A(float v,float z)
 {
   return 1./(v*(1.-z)+z);
 }
 void A(inout vec3 v,in vec3 z,in vec3 f,vec3 m,float s)
 {
   float x=length(z);
   #ifdef FADE_TO_ATMOSPHERE
   float i=length(z)/far;
   i=pow(i,6.)*.07+pow(i,2.)*.003;
   #else
   float y=length(z)/300.;
   y=pow(y,3.)*.002;
   #endif
   y*=pow(eyeBrightnessSmooth.y/240.f,6.f);
   y=clamp(y,0.,.03);
   y/=saturate(m.y)*2.+1.;
   vec3 e=vec3(.2,.45,1.);
   v*=exp(-y*e*100.67);
   v+=AtmosphericScattering(normalize(m),worldSunVector,1.,y)*.9*mix(s,1.,.5)*mix(1.,.35,wetness)*.001;
 }
 void a(inout vec3 v,in vec3 z,in vec3 f,vec3 m,float s)
 {
   float i=length(z);
   i*=pow(eyeBrightnessSmooth.y/240.f,6.f);
   i*=rainStrength;
   float y=pow(exp(-i*1e-05),4.);
   vec3 x=vec3(dot(skyUpColor,vec3(1.)))*.001;
   v=mix(x,v,vec3(y));
 }
 void main()
 {
   GBufferData v=GetGBufferData();
   GBufferDataTransparent m=GetGBufferDataTransparent();
   MaterialMask f=CalculateMasks(v.materialID);
   bool z=m.depth<v.depth;
   if(z)
     v.normal=m.normal,v.smoothness=m.smoothness,v.metalness=0.,v.mcLightmap=m.mcLightmap,v.depth=m.depth;
   vec4 i=GetViewPosition(texcoord.xy,v.depth),s=gbufferModelViewInverse*vec4(i.xyz,1.),p=gbufferModelViewInverse*vec4(i.xyz,0.);
   vec3 y=normalize(i.xyz),x=normalize(p.xyz),r=normalize((gbufferModelViewInverse*vec4(v.normal,0.)).xyz);
   float d=ExpToLinearDepth(v.depth),e=1.-v.smoothness,b=e*e,t=a(v.smoothness,v.metalness);
   int w=0;
   vec4 G=texture2DLod(colortex6,texcoord.xy,w),q=G;
   float n=1.-v.smoothness,c=n*n;
   vec3 h=r,O=-x,l=normalize(reflect(-O,h)+h*c),F=normalize(O+l);
   float g=saturate(dot(h,l)),P=saturate(dot(h,O)),u=saturate(dot(h,F)),S=saturate(dot(l,F)),U=v.metalness*.98+.02,B=pow(1.-S,5.),k=U+(1.-U)*B,D=c/2.,Q=A(g,D)*A(P+.8,D),L=g*k*Q;
   q.xyz*=mix(vec3(1.),v.albedo.xyz,vec3(v.metalness));
   L=mix(L,1.,v.metalness);
   if(v.depth>.99999)
     L=0.;
   L*=a(v.smoothness,v.metalness);
   vec4 T=texture2DLod(colortex3,texcoord.xy,0);
   vec3 E=pow(T.xyz,vec3(2.2)),Z=mix(E,q.xyz*.01,vec3(L));
   Z+=E*v.metalness;
   if(f.sky<.5&&!z)
     A(Z,i.xyz,y.xyz,x.xyz,1.);
   a(Z,i.xyz,y.xyz,x.xyz,1.);
   Z=pow(Z.xyz,vec3(.454545));
   gl_FragData[0]=vec4(Z,T.w);
 };

/* DRAWBUFFERS:3 */