#version 330 compatibility



/*
 _______ _________ _______  _______  _ 
(  ____ \\__   __/(  ___  )(  ____ )( )
| (    \/   ) (   | (   ) || (    )|| |
| (_____    | |   | |   | || (____)|| |
(_____  )   | |   | |   | ||  _____)| |
      ) |   | |   | |   | || (      (_)
/\____) |   | |   | (___) || )       _ 
\_______)   )_(   (_______)|/       (_)

Do not modify this code until you have read the LICENSE.txt contained in the root directory of this shaderpack!

*/

/////////ADJUSTABLE VARIABLES//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////ADJUSTABLE VARIABLES//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



//#define HALF_RES_TRACE

/////////INTERNAL VARIABLES////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////INTERNAL VARIABLES////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Do not change the name of these variables or their type. The Shaders Mod reads these lines and determines values to send to the inner-workings
//of the shaders mod. The shaders mod only reads these lines and doesn't actually know the real value assigned to these variables in GLSL.
//Some of these variables are critical for proper operation. Change at your own risk.

const bool colortex4Clear = false;
const bool colortex5Clear = false;
//END OF INTERNAL VARIABLES//




in vec4 texcoord;

in float timeMidnight;

in vec3 colorSunlight;
in vec3 colorSkylight;
in vec3 colorSkyUp;
in vec3 colorTorchlight;

in vec4 skySHR;
in vec4 skySHG;
in vec4 skySHB;


in vec3 worldLightVector;
in vec3 worldSunVector;


in mat4 gbufferPreviousModelViewInverse;
in mat4 gbufferPreviousProjectionInverse;


#include "lib/Uniforms.inc"
#include "lib/Common.inc"

#include "lib/Materials.inc"


/////////////////////////FUNCTIONS/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////FUNCTIONS/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////






// vec4 GetViewPosition(in vec2 coord, in float depth) 
// {	
// 	vec2 tcoord = coord;
// 	TemporalJitterProjPosInv01(tcoord);

// 	vec4 fragposition = gbufferProjectionInverse * vec4(tcoord.s * 2.0f - 1.0f, tcoord.t * 2.0f - 1.0f, 2.0f * depth - 1.0f, 1.0f);
// 		 fragposition /= fragposition.w;

	
// 	return fragposition;
// }




vec2 GetNearFragment(vec2 coord, float depth, out float minDepth)
{
	
	
	vec2 texel = 1.0 / vec2(viewWidth, viewHeight);
	vec4 depthSamples;
	depthSamples.x = texture2D(depthtex1, coord + texel * vec2(1.0, 1.0)).x;
	depthSamples.y = texture2D(depthtex1, coord + texel * vec2(1.0, -1.0)).x;
	depthSamples.z = texture2D(depthtex1, coord + texel * vec2(-1.0, 1.0)).x;
	depthSamples.w = texture2D(depthtex1, coord + texel * vec2(-1.0, -1.0)).x;

	vec2 targetFragment = vec2(0.0, 0.0);

	if (depthSamples.x < depth)
		targetFragment = vec2(1.0, 1.0);
	if (depthSamples.y < depth)
		targetFragment = vec2(1.0, -1.0);
	if (depthSamples.z < depth)
		targetFragment = vec2(-1.0, 1.0);
	if (depthSamples.w < depth)
		targetFragment = vec2(-1.0, -1.0);


	minDepth = min(min(min(depthSamples.x, depthSamples.y), depthSamples.z), depthSamples.w);

	return coord + texel * targetFragment;
}















#include "lib/GBufferData.inc"










 int t(float v)
 {
   return int(floor(v));
 }
 int d(int v)
 {
   return v-t(mod(float(v),2.))-0;
 }
 int f(int v)
 {
   return v-t(mod(float(v),2.))-1;
 }
 int d()
 {
   ivec2 v=ivec2(viewWidth,viewHeight);
   int f=v.x*v.y;
   return d(t(floor(pow(float(f),.333333))));
 }
 int f()
 {
   ivec2 v=ivec2(2048,2048);
   int y=v.x*v.y;
   return f(t(floor(pow(float(y),.333333))));
 }
 vec3 v(vec2 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int x=f.x*f.y,y=d();
   ivec2 n=ivec2(v.x*f.x,v.y*f.y);
   float z=float(n.y/y),r=float(int(n.x+mod(f.x*z,y))/y);
   r+=floor(f.x*z/y);
   vec3 i=vec3(0.,0.,r);
   i.x=mod(n.x+mod(f.x*z,y),y);
   i.y=mod(n.y,y);
   i.xyz=floor(i.xyz);
   i/=y;
   i.xyz=i.xzy;
   return i;
 }
 vec2 s(vec3 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int z=d();
   vec3 i=v.xzy*z;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 r;
   r.x=mod(i.x+x*z,f.x);
   float s=i.x+x*z;
   r.y=i.y+floor(s/f.x)*z;
   r+=.5;
   r/=f;
   return r;
 }
 vec3 e(vec2 v)
 {
   vec2 i=v;
   i.xy/=.5;
   ivec2 s=ivec2(2048,2048);
   int x=s.x*s.y,y=f();
   ivec2 n=ivec2(i.x*s.x,i.y*s.y);
   float z=float(n.y/y),r=float(int(n.x+mod(s.x*z,y))/y);
   r+=floor(s.x*z/y);
   vec3 m=vec3(0.,0.,r);
   m.x=mod(n.x+mod(s.x*z,y),y);
   m.y=mod(n.y,y);
   m.xyz=floor(m.xyz);
   m/=y;
   m.xyz=m.xzy;
   return m;
 }
 vec2 d(vec3 v,int y)
 {
   v=clamp(v,vec3(0.),vec3(1.));
   ivec2 f=ivec2(2048,2048);
   vec3 i=v.xzy*y;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 r;
   r.x=mod(i.x+x*y,f.x);
   float s=i.x+x*y;
   r.y=i.y+floor(s/f.x)*y;
   r+=.5;
   r/=f;
   r.xy*=.5;
   return r;
 }
 vec3 e(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v=clamp(v,vec3(0.),vec3(1.)),v;
 }
 vec3 f(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v;
 }
 vec3 m(vec3 v)
 {
   int m=f();
   v=v-vec3(.5);
   v*=m;
   return v;
 }
 vec3 r(vec3 v)
 {
   int y=d();
   v*=1./y;
   v=v+vec3(.5);
   v=clamp(v,vec3(0.),vec3(1.));
   return v;
 }
 vec3 n(vec3 v)
 {
   int f=d();
   v=v-vec3(.5);
   v*=f;
   return v;
 }
 vec3 x(vec3 v)
 {
   vec4 f=vec4(v,1.);
   f.xyz+=1.;
   f.xyz-=Fract01(cameraPosition.xyz+.5);
   f=shadowModelView*f;
   f=shadowProjection*f;
   f/=f.w;
   float x=sqrt(f.x*f.x+f.y*f.y),y=1.f-SHADOW_MAP_BIAS+x*SHADOW_MAP_BIAS;
   f.xy*=.95f/y;
   f.z=mix(f.z,.5,.8);
   f=f*.5f+.5f;
   f.xy*=.5;
   f.xy+=.5;
   return f.xyz;
 }struct zNBzKgUtly{float AvJUxmdirG;float WCbWyvymZz;float ABrGOYvmhP;float dyVwWpTUTv;vec3 kVdfXZomUb;};
 vec4 p(zNBzKgUtly v)
 {
   vec4 f;
   v.kVdfXZomUb=max(vec3(0.),v.kVdfXZomUb);
   f.x=v.AvJUxmdirG;
   v.kVdfXZomUb=pow(v.kVdfXZomUb,vec3(.25));
   f.y=PackTwo16BitTo32Bit(v.kVdfXZomUb.x,v.ABrGOYvmhP);
   f.z=PackTwo16BitTo32Bit(v.kVdfXZomUb.y,v.dyVwWpTUTv);
   f.w=PackTwo16BitTo32Bit(v.kVdfXZomUb.z,v.WCbWyvymZz);
   return f;
 }
 zNBzKgUtly w(vec4 v)
 {
   zNBzKgUtly f;
   vec2 i=UnpackTwo16BitFrom32Bit(v.y),m=UnpackTwo16BitFrom32Bit(v.z),n=UnpackTwo16BitFrom32Bit(v.w);
   f.AvJUxmdirG=v.x;
   f.ABrGOYvmhP=i.y;
   f.dyVwWpTUTv=m.y;
   f.WCbWyvymZz=n.y;
   f.kVdfXZomUb=pow(vec3(i.x,m.x,n.x),vec3(4.));
   return f;
 }
 zNBzKgUtly g(vec2 v)
 {
   vec2 f=1./vec2(viewWidth,viewHeight),y=vec2(viewWidth,viewHeight);
   v=(floor(v*y)+.5)*f;
   return w(texture2DLod(colortex5,v,0));
 }
 float g(float v,float y)
 {
   float f=1.;
   #ifdef FULL_RT_REFLECTIONS
   f=clamp(pow(v,.125)+y,0.,1.);
   #else
   f=clamp(v*10.-7.,0.,1.);
   #endif
   return f;
 }
 void d(inout float v,inout float f,float y,float z,vec3 i,float t)
 {
   v*=mix(2.,2.4,z);
   float x=dot(i,vec3(1.));
   f*=1.-pow(z,1.);
   f/=y*.1+2e-06;
   f*=4.;
   f*=.1;
   float r=y/(x+1e-07)*.2+4e-08;
   r=min(r,1.);
   r=mix(r,1.,pow(z,.25));
   if(t<.12)
     f=0.;
 }
 float d(vec3 v,vec3 y,float f)
 {
   float r=dot(abs(v-y),vec3(.3333));
   r*=f;
   r*=.18;
   return r;
 }
 void e(inout vec3 v,vec2 z,vec3 y)
 {}
 float m(float v,float y)
 {
   return v/(y*20.01+1.);
 }struct Ray{vec3 dir;vec3 origin;};struct BBRay{vec3 origin;vec3 direction;vec3 inv_direction;ivec3 sign;};
 BBRay n(vec3 v,vec3 y)
 {
   vec3 f=vec3(1.)/y;
   return BBRay(v,y,f,ivec3(f.x<0?1:0,f.y<0?1:0,f.z<0?1:0));
 }
 void d(in BBRay v,in vec3 f[2],out float r,out float y)
 {
   float z,i,x,t;
   r=(f[v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   y=(f[1-v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   z=(f[v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   i=(f[1-v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   x=(f[v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   t=(f[1-v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   r=max(max(r,z),x);
   y=min(min(y,i),t);
 }
 vec2 i(inout float v)
 {
   return fract(sin(vec2(v+=.1,v+=.1))*vec2(43758.5,22578.1));
 }
 float h(vec2 v)
 {
   v*=vec2(viewWidth,viewHeight);
   const float f=1.61803,y=1.32472;
   return fract(dot(v,1./vec2(f,y*y)));
 }
 vec3 c(vec2 v)
 {
   vec2 f=vec2(v.xy*vec2(viewWidth,viewHeight))/64.;
   const vec2 m[16]=vec2[16](vec2(-1,-1),vec2(0,-.333333),vec2(-.5,.333333),vec2(.5,-.777778),vec2(-.75,-.111111),vec2(.25,.555556),vec2(-.25,-.555556),vec2(.75,.111111),vec2(-.875,.777778),vec2(.125,-.925926),vec2(-.375,-.259259),vec2(.625,.407407),vec2(-.625,-.703704),vec2(.375,-.037037),vec2(-.125,.62963),vec2(.875,-.481482));
   if(v.x<2./viewWidth||v.x>1.-2./viewWidth||v.y<2./viewHeight||v.y>1.-2./viewHeight)
     ;
   else
      f+=m[int(mod(frameCounter,8))]*.5;
   f=(floor(f*64.)+.5)/64.;
   vec3 y=texture2D(noisetex,f).xyz,i=vec3(sqrt(.2),sqrt(2.),1.61803);
   return y;
 }
 vec3 c(vec3 v,inout float y,int f)
 {
   vec2 i=c(texcoord.xy+vec2(0.,0.)).xy;
   i=i*.99+.005;
   float t=6.28319*i.x,z=sqrt(i.y);
   vec3 x=normalize(cross(v,vec3(0.,1.,1.))),r=cross(v,x),o=x*cos(t)*z+r*sin(t)*z+v.xyz*sqrt(1.-i.y);
   return o;
 }
 vec3 B(inout float v)
 {
   vec3 f=c(texcoord.xy).xyz;
   f=fract(f+vec3(i(v),i(v).x)*.1);
   f=f*2.-1.;
   f=normalize(f);
   return f;
 }
 float B(vec3 v,vec3 y,vec3 f,int z)
 {
   if(rainStrength>.99)
     return 0.f;
   vec3 i=m(v),n=x(i+y*.99);
   float r=.5,t=shadow2DLod(shadowtex0,vec3(n.xy,n.z-.0006*r),3).x;
   t*=saturate(dot(worldLightVector,y));
   return t*(1.-rainStrength);
 }
 float c(vec3 v,vec3 y,vec3 f,int z)
 {
   if(rainStrength>.99)
     return 0.f;
   vec3 i=x(v);
   float r=.5,t=shadow2DLod(shadowtex0,vec3(i.xy,i.z-.0006*r),2).x;
   t*=saturate(dot(worldLightVector,y));
   return t*(1.-rainStrength);
 }
 vec3 B()
 {
   vec3 v=cameraPosition.xyz+.5-Fract01(cameraPosition.xyz+.5),y=previousCameraPosition+.5-Fract01(previousCameraPosition+.5);
   return v-y;
 }
 vec3 B(vec3 v,vec3 y)
 {
   vec2 f=s(r(m(v)+y+1.+B()));
   vec3 z=g(f).kVdfXZomUb;
   return z;
 }
 vec3 c()
 {
   vec2 f=s(v(texcoord.xy)+B()/d());
   vec3 y=g(f).kVdfXZomUb;
   return y;
 }
 bool c(ivec3 v,BBRay f)
 {
   vec3 y=vec3(v),z=vec3(v)+1.,t=mix(y,z,vec3(.5));
   float i=mix(.25,0.,saturate(distance(f.origin,t)*.5-1.));
   vec3 r[2]=vec3[2](mix(y,z,vec3(i)),mix(y,z,vec3(1.-i)));
   float x,m;
   d(f,r,x,m);
   return x<=m;
 }
 vec3 B(vec3 v,vec3 y,vec3 x,vec3 z,vec3 r,MaterialMask i,float t,vec2 h,float s,out float w)
 {
   float m=fract(frameCounter*.0123456),o=1.;
   #ifdef SUNLIGHT_LEAK_FIX
   o=saturate(t*100.);
   #endif
   vec3 g=c(z,m,0);
   w=100.;
   #ifdef GI_SCREEN_SPACE_TRACING
   bool T=false;
   {
     const int G=8;
     float p=.25*-y.z;
     p=mix(p,.8,.5);
     float A=.07*-y.z;
     A=mix(A,1.,.5);
     A=.4;
     vec2 R=texcoord.xy;
     vec3 l=y.xyz,a=normalize((gbufferModelView*vec4(g.xyz,0.)).xyz);
     for(int D=0;D<G;D++)
       {
         float S=float(D),k=(S+.5)/float(G),M=p*k;
         vec3 F=y.xyz+a*M,P=ProjectBack(F),U=GetViewPositionNoJitter(P.xy,GetDepth(P.xy)).xyz;
         float u=length(F)-length(U)-.02;
         if(u>0.&&u<A)
           {
             T=true;
             R=P.xy;
             l=U.xyz;
             break;
           }
       }
     vec3 D=(gbufferModelViewInverse*vec4(l,1.)).xyz;
     D+=Fract01(cameraPosition.xyz+.5)+.5;
     if(T)
       {
         vec3 S=pow(texture2DLod(colortex7,R.xy-h*.5,0).xyz,vec3(2.2));
         S*=1.-saturate(s*1.1);
         return S*80.;
       }
   }
   #endif
   if(i.leaves>.5)
     ;
   int A=f();
   vec3 p=v+x*(.001-i.leaves*.01);
   p+=Fract01(cameraPosition.xyz+.5);
   vec3 S=p;
   p=e(p,A);
   float G=1./float(A);
   Ray a;
   a.origin=p*A-vec3(1.,1.,1.);
   a.dir=g;
   BBRay l=n(a.origin,a.dir);
   vec3 D=vec3(1.),R=vec3(0.);
   float u=0.;
   {
     vec3 P=vec3(floor(a.origin)),k=abs(vec3(length(a.dir))/(a.dir+.0001)),M=sign(a.dir),U=(sign(a.dir)*(P-a.origin)+sign(a.dir)*.5+.5)*k,F;
     vec4 C=vec4(0.);
     vec3 b=vec3(0.);
     float I=.5;
     for(int L=0;L<DIFFUSE_TRACE_LENGTH;L++)
       {
         b=P/float(A);
         vec2 N=d(b,A);
         C=texture2DLod(shadowcolor,N,0);
         u=C.w*255.;
         float O=1.-step(.5,abs(u-GI_ID_NONBLOCK_LIGHT));
         vec3 E=C.xyz;
         R+=GI_NONBLOCK_LIGHT_BRIGHTNESS*E*O*I*.5;
         if(u<GI_ID_FIRST_NONSOLID&&L!=0)
           {
             break;
           }
         F=step(U.xyz,U.yzx)*step(U.xyz,U.zxy);
         U+=F*k;
         P+=F*M;
         I=1.;
       }
     if(u<1.f||u>254.f)
       {
         vec3 L=SkyShading(a.dir,worldSunVector,rainStrength);
         L*=saturate(a.dir.y*10.+1.);
         L=DoNightEyeAtNight(L*12.,timeMidnight)*.083333;
         R+=L*.1;
       }
     else
       {
         if(abs(u-GI_ID_BLOCK_LIGHT)<.1)
           R+=.09*D*C.xyz*GI_LIGHT_BLOCK_INTENSITY;
         if(u<GI_ID_FIRST_NONSOLID)
           {
             vec3 L=saturate(C.xyz);
             D*=L;
             vec3 N=-(F*M);
             R+=B(b,N)*D*2.;
             vec3 O[2]=vec3[2](P,P+1.);
             float E,H;
             d(l,O,E,H);
             const float V=2.4;
             float W=c(S+a.dir*E-1.,N,g,A);
             R+=DoNightEyeAtNight(W*D*V*colorSunlight*o*12.,timeMidnight)/12.;
             w=E;
           }
       }
   }
   R/=saturate(dot(z,g))+.01;
   R*=saturate(dot(x,g));
   w*=.5;
   return R;
 }
 vec3 e()
 {
   int y=f();
   vec3 i=v(texcoord.xy),m=n(i),z=e(m-vec3(1.,1.,0.),y);
   vec2 x=d(z,y);
   float r=1000.;
   r=min(r,texture2DLod(shadowcolor,d(e(m-vec3(0.,0.,0.),y),y)+vec2(.5,.5)/float(4096),0).w);
   r=min(r,texture2DLod(shadowcolor,d(e(m-vec3(0.,0.,0.),y),y)+vec2(-.5,-.5)/float(4096),0).w);
   r=min(r,texture2DLod(shadowcolor,d(e(m-vec3(0.,1.,0.),y),y)+vec2(0.,0.)/float(4096),0).w);
   r=min(r,texture2DLod(shadowcolor,d(e(m-vec3(0.,-1.,0.),y),y)+vec2(0.,0.)/float(4096),0).w);
   float t=texture2DLod(shadowcolor,d(e(m-vec3(0.,0.,0.),y),y),0).w;
   if(r*255.>GI_ID_FIRST_NONSOLID||t*255.<GI_ID_FIRST_NONSOLID)
     return vec3(0.);
   vec3 s=vec3(0.);
   for(int R=0;R<GI_SECONDARY_SAMPLES;R++)
     {
       float A=sin(frameTimeCounter*1.1)+m.x*.11+m.y*.12+m.z*.13+R*.1;
       vec3 a=normalize(rand(vec2(A))*2.-1.);
       a.x+=a.x==a.y||a.x==a.z?.01:0.;
       a.y+=a.y==a.z?.01:0.;
       vec3 c=m+vec3(1.,1.,1.);
       c=e(c,y);
       Ray p;
       p.origin=c*y-vec3(1.,1.,1.);
       p.dir=a;
       vec3 D=vec3(1.);
       for(int L=0;L<1;L++)
         {
           vec3 g=vec3(floor(p.origin)),o=g,w=abs(vec3(length(p.dir))/(p.dir+.0001)),T=sign(p.dir),U=(sign(p.dir)*(g-p.origin)+sign(p.dir)*.5+.5)*w,G;
           vec4 P=vec4(0.);
           float u=0.;
           vec3 h=vec3(0.);
           float S=.2;
           for(int l=0;l<DIFFUSE_TRACE_LENGTH;l++)
             {
               h=g/float(y);
               vec2 N=d(h,y);
               P=texture2DLod(shadowcolor,N,0);
               u=P.w*255.;
               float F=1.-step(.5,abs(u-GI_ID_NONBLOCK_LIGHT));
               vec3 E=P.xyz;
               s+=GI_NONBLOCK_LIGHT_BRIGHTNESS*E*S*F*(l==0?.5:1.);
               if(u<GI_ID_FIRST_NONSOLID)
                 {
                   break;
                 }
               G=step(U.xyz,U.yzx)*step(U.xyz,U.zxy);
               U+=G*w;
               g+=G*T;
               S=saturate(S*1.3);
             }
           float F=1.;
           if(abs(g.x-o.x)<2||abs(g.y-o.y)<2||abs(g.z-o.z)<2)
             F=0.;
           if(u<1.f||u>254.f)
             {
               vec3 l=SkyShading(p.dir,worldSunVector,rainStrength);
               l*=saturate(p.dir.y*10.+1.);
               l=DoNightEyeAtNight(l*12.,timeMidnight)*.083333;
               s+=l*.1;
             }
           if(abs(u-GI_ID_BLOCK_LIGHT)<.1)
             s+=.09*D*P.xyz*GI_LIGHT_BLOCK_INTENSITY;
           if(u<GI_ID_FIRST_NONSOLID)
             {
               vec3 l=saturate(P.xyz);
               D*=l;
               vec3 N=-(G*T);
               float E=2.4,M=B(h,N,a,y);
               s+=DoNightEyeAtNight(M*E*colorSunlight*F*12.,timeMidnight)/12.;
               s+=B(h,N);
             }
           s*=D;
         }
     }
   s/=float(GI_SECONDARY_SAMPLES);
   return saturate(s);
 }
 vec4 G(float y)
 {
   float v=y*y,f=v*y;
   vec4 r;
   r.x=-f+3*v-3*y+1;
   r.y=3*f-6*v+4;
   r.z=-3*f+3*v+3*y+1;
   r.w=f;
   return r/6.f;
 }
 vec4 G(in sampler2D v,in vec2 f)
 {
   vec2 y=vec2(viewWidth,viewHeight);
   f*=y;
   f-=.5;
   float i=fract(f.x),t=fract(f.y);
   f.x-=i;
   f.y-=t;
   vec4 r=G(i),n=G(t),m=vec4(f.x-.5,f.x+1.5,f.y-.5,f.y+1.5),z=vec4(r.x+r.y,r.z+r.w,n.x+n.y,n.z+n.w),a=m+vec4(r.y,r.w,n.y,n.w)/z,x=texture2DLod(v,vec2(a.x,a.z)/y,0),s=texture2DLod(v,vec2(a.y,a.z)/y,0),h=texture2DLod(v,vec2(a.x,a.w)/y,0),p=texture2DLod(v,vec2(a.y,a.w)/y,0);
   float A=z.x/(z.x+z.y),w=z.z/(z.z+z.w);
   return mix(mix(p,h,A),mix(s,x,A),w);
 }
 bool h(vec3 v,vec3 y)
 {
   vec3 f=normalize(cross(dFdx(v),dFdy(v))),i=normalize(y-v),r=normalize(i);
   float z=.25+length(v)*.04;
   return distance(v,y)<z;
 }
 vec3 D(vec2 v)
 {
   vec2 y=vec2(viewWidth,viewHeight),f=1./y,i=v*y,z=floor(i-.5)+.5,x=i-z,r=x*x,m=x*r;
   float t=.5;
   vec2 n=-t*m+2.*t*r-t*x,s=(2.-t)*m-(3.-t)*r+1.,h=-(2.-t)*m+(3.-2.*t)*r+t*x,a=t*m-t*r,p=s+h,U=f*(z+h/p);
   vec3 l=texture2DLod(colortex4,vec2(U.x,U.y),0).xyz;
   vec2 g=f*(z-1.),A=f*(z+2.);
   vec4 o=vec4(texture2DLod(colortex4,vec2(U.x,g.y),0).xyz,1.)*(p.x*n.y)+vec4(texture2DLod(colortex4,vec2(g.x,U.y),0).xyz,1.)*(n.x*p.y)+vec4(l,1.)*(p.x*p.y)+vec4(texture2DLod(colortex4,vec2(A.x,U.y),0).xyz,1.)*(a.x*p.y)+vec4(texture2DLod(colortex4,vec2(U.x,A.y),0).xyz,1.)*(p.x*a.y);
   return max(vec3(0.),o.xyz*(1./o.w));
 }
 vec2 B(float v,vec2 f,out float y,out vec2 r,out vec4 i)
 {
   float z;
   vec2 t=GetNearFragment(texcoord.xy,v,z);
   y=texture2D(depthtex1,t).x;
   vec4 m=vec4(texcoord.xy*2.-1.,y*2.-1.,1.),n=gbufferProjectionInverse*m;
   n.xyz/=n.w;
   vec4 x=gbufferModelViewInverse*vec4(n.xyz,1.);
   i=x;
   i.xyz+=cameraPosition-previousCameraPosition;
   vec4 a=gbufferPreviousModelView*vec4(i.xyz,1.),s=gbufferPreviousProjection*vec4(a.xyz,1.);
   s.xyz/=s.w;
   r=m.xy-s.xy;
   float p=length(r)*10.,A=clamp(p*500.,0.,1.);
   vec2 l=f.xy-r.xy*.5;
   if(y<.7)
     l=texcoord.xy;
   return l;
 }
 void main()
 {
   GBufferData v=GetGBufferData();
   MaterialMask f=CalculateMasks(v.materialID);
   vec4 i=GetViewPosition(texcoord.xy,v.depth),y=gbufferModelViewInverse*vec4(i.xyz,1.),n=gbufferModelViewInverse*vec4(i.xyz,0.);
   vec3 r=normalize(i.xyz),a=normalize(n.xyz),z=normalize((gbufferModelViewInverse*vec4(v.normal,0.)).xyz),x=normalize((gbufferModelViewInverse*vec4(v.geoNormal,0.)).xyz);
   float l=length(i.xyz),m=dot(v.mcLightmap.xy,vec2(.5));
   if(f.grass>.5)
     ;
   vec4 t=vec4(texcoord.xy,0.,0.);
   float s;
   vec2 A;
   vec4 U;
   vec2 d=B(v.depth,t.xy,s,A,U),u=d.xy;
   u-=(vec2(mod(frameCounter/2,2),mod(frameCounter,2))-.5)/vec2(viewWidth,viewHeight)*1.5;
   vec3 o=D(u.xy);
   zNBzKgUtly w=g(d.xy);
   float G=1./(saturate(-dot(v.geoNormal,r))*100.+1.);
   vec4 P=vec4(d.xy,0.,0.);
   TemporalJitterProjPosPrevInv(P);
   vec4 R=gbufferPreviousProjectionInverse*vec4(d.xy*2.-1.,texture2DLod(colortex7,P.xy,0).w*2.-1.,1.);
   R/=R.w;
   vec3 N=(gbufferPreviousModelViewInverse*vec4(R.xyz,1.)).xyz;
   w.AvJUxmdirG+=1.;
   w.AvJUxmdirG=min(w.AvJUxmdirG,2.);
   vec2 S=1./vec2(viewWidth,viewHeight),T=1.-S;
   float F=0.,M=1.-exp2(-w.AvJUxmdirG);
   if(!h(U.xyz,N.xyz)||(d.x<S.x||d.x>T.x||d.y<S.y||d.y>T.y)||abs(G-w.ABrGOYvmhP)>.01)
     M=0.,F=.99,w.AvJUxmdirG=0.;
   float k;
   vec3 L=B(y.xyz,i.xyz,z.xyz,x,a.xyz,f,v.mcLightmap.y,A,F,k);
   L=max(vec3(0.),L);
   L=mix(L,o,vec3(M));
   w.ABrGOYvmhP=G;
   w.dyVwWpTUTv=mix(w.dyVwWpTUTv,F,mix(.5,1.,F));
   w.WCbWyvymZz=m;
   vec3 E=e();
   w.kVdfXZomUb=mix(c(),E,vec3(.015));
   vec4 b=p(w);
   gl_FragData[0]=vec4(L,saturate(s));
   gl_FragData[1]=vec4(b);
   gl_FragData[2]=vec4(L,k);
 };

/* DRAWBUFFERS:456 */