#version 330 compatibility

/*
 _______ _________ _______  _______  _
(  ____ \\__   __/(  ___  )(  ____ )( )
| (    \/   ) (   | (   ) || (    )|| |
| (_____    | |   | |   | || (____)|| |
(_____  )   | |   | |   | ||  _____)| |
      ) |   | |   | |   | || (      (_)
/\____) |   | |   | (___) || )       _
\_______)   )_(   (_______)|/       (_)

Do not modify this code until you have read the LICENSE.txt contained in the root directory of this shaderpack!

*/

/////////////////////////CONFIGURABLE VARIABLES////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////CONFIGURABLE VARIABLES////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////END OF CONFIGURABLE VARIABLES/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////END OF CONFIGURABLE VARIABLES/////////////////////////////////////////////////////////////////////////////////////////////////////////////











const int 		shadowMapResolution 	= 4096;
const float 	shadowDistance 			= 120.0; // Shadow distance. Set lower if you prefer nicer close shadows. Set higher if you prefer nicer distant shadows. [80.0 120.0 180.0 240.0]
const float 	shadowIntervalSize 		= 1.0f;
const bool 		shadowHardwareFiltering0 = true;

const bool 		shadowtexMipmap = true;
const bool 		shadowtex1Mipmap = false;
const bool 		shadowtex1Nearest = false;
const bool 		shadowcolor0Mipmap = false;
const bool 		shadowcolor0Nearest = false;
const bool 		shadowcolor1Mipmap = false;
const bool 		shadowcolor1Nearest = false;

const float shadowDistanceRenderMul = 1.0f;

const int 		RGB8 					= 0;
const int 		RGBA8 					= 0;
const int 		RGBA16 					= 0;
const int 		RGBA16F 				= 0;
const int 		RGBA32F 				= 0;
const int 		RG16 					= 0;
const int 		RGB16 					= 0;
const int 		R11F_G11F_B10F 			= 0;
const int 		colortex0Format 			= RGB8;
const int 		colortex1Format 			= RGBA16;
const int 		colortex2Format 			= RGBA16;
const int 		colortex3Format 			= RGBA16;
const int 		colortex4Format 			= RGBA16F;
const int 		colortex5Format 			= RGBA32F;
const int 		colortex6Format 			= RGBA16F;
const int 		colortex7Format 			= RGBA16;


const int 		superSamplingLevel 		= 0;

const float		sunPathRotation 		= -40.0f;

const int 		noiseTextureResolution  = 64;

const float 	ambientOcclusionLevel 	= 0.06f;


const bool colortex7Clear = false;

const float wetnessHalflife = 100.0;
const float drynessHalflife = 100.0;




in vec4 texcoord;

in vec3 lightVector;
in vec3 worldLightVector;
in vec3 worldSunVector;

in float timeMidnight;

in vec3 colorSunlight;
in vec3 colorSkylight;
in vec3 colorSkyUp;
in vec3 colorTorchlight;

in vec4 skySHR;
in vec4 skySHG;
in vec4 skySHB;









#include "lib/Uniforms.inc"
#include "lib/Common.inc"
#include "lib/Materials.inc"



/////////////////////////FUNCTIONS/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////FUNCTIONS/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// vec4 GetViewPosition(in vec2 coord, in float depth) 
// {	
// 	vec2 tcoord = coord;
// 	TemporalJitterProjPosInv01(tcoord);

// 	vec4 fragposition = gbufferProjectionInverse * vec4(tcoord.s * 2.0f - 1.0f, tcoord.t * 2.0f - 1.0f, 2.0f * depth - 1.0f, 1.0f);
// 		 fragposition /= fragposition.w;

	
// 	return fragposition;
// }




/////////////////////////STRUCTS///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////STRUCTS///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


#include "lib/GBufferData.inc"




struct Ray {
	vec3 dir;
	vec3 origin;
};

struct Plane {
	vec3 normal;
	vec3 origin;
};

struct Intersection {
	vec3 pos;
	float distance;
	float angle;
};

/////////////////////////STRUCT FUNCTIONS//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////STRUCT FUNCTIONS//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





Intersection 	RayPlaneIntersectionWorld(in Ray ray, in Plane plane)
{
	float rayPlaneAngle = dot(ray.dir, plane.normal);

	float planeRayDist = 100000000.0f;
	vec3 intersectionPos = ray.dir * planeRayDist;

	if (rayPlaneAngle > 0.0001f || rayPlaneAngle < -0.0001f)
	{
		planeRayDist = dot((plane.origin), plane.normal) / rayPlaneAngle;
		intersectionPos = ray.dir * planeRayDist;
		intersectionPos = -intersectionPos;

		intersectionPos += cameraPosition.xyz;
	}

	Intersection i;

	i.pos = intersectionPos;
	i.distance = planeRayDist;
	i.angle = rayPlaneAngle;

	return i;
}

Intersection 	RayPlaneIntersection(in Ray ray, in Plane plane)
{
	float rayPlaneAngle = dot(ray.dir, plane.normal);

	float planeRayDist = 100000000.0f;
	vec3 intersectionPos = ray.dir * planeRayDist;

	if (rayPlaneAngle > 0.0001f || rayPlaneAngle < -0.0001f)
	{
		planeRayDist = dot((plane.origin - ray.origin), plane.normal) / rayPlaneAngle;
		intersectionPos = ray.origin + ray.dir * planeRayDist;
		// intersectionPos = -intersectionPos;

		// intersectionPos += cameraPosition.xyz;
	}

	Intersection i;

	i.pos = intersectionPos;
	i.distance = planeRayDist;
	i.angle = rayPlaneAngle;

	return i;
}


vec3 CalculateSunlightVisibility(vec4 screenSpacePosition, MaterialMask mask) {				//Calculates shadows
	if (rainStrength >= 0.99f)
		return vec3(1.0f);



	//if (shadingStruct.direct > 0.0f) {
		float distance = sqrt(  screenSpacePosition.x * screenSpacePosition.x 	//Get surface distance in meters
							  + screenSpacePosition.y * screenSpacePosition.y
							  + screenSpacePosition.z * screenSpacePosition.z);

		vec4 ssp = screenSpacePosition;

		// if (isEyeInWater > 0.5)
		// {
		// 	ssp.xy *= 0.82;
		// }

		vec4 worldposition = vec4(0.0f);
			 worldposition = gbufferModelViewInverse * ssp;		//Transform from screen space to world space


		float yDistanceSquared  = worldposition.y * worldposition.y;

		worldposition = shadowModelView * worldposition;	//Transform from world space to shadow space
		float comparedepth = -worldposition.z;				//Surface distance from sun to be compared to the shadow map

		worldposition = shadowProjection * worldposition;
		worldposition /= worldposition.w;

		float dist = sqrt(worldposition.x * worldposition.x + worldposition.y * worldposition.y);
		float distortFactor = (1.0f - SHADOW_MAP_BIAS) + dist * SHADOW_MAP_BIAS;
		worldposition.xy *= 0.95f / distortFactor;
		worldposition.z = mix(worldposition.z, 0.5, 0.8);
		worldposition = worldposition * 0.5f + 0.5f;		//Transform from shadow space to shadow map coordinates

		float shadowMult = 0.0f;																			//Multiplier used to fade out shadows at distance
		float shading = 0.0f;

		float fademult = 0.15f;
			shadowMult = clamp((shadowDistance * 1.4f * fademult) - (distance * fademult), 0.0f, 1.0f);	//Calculate shadowMult to fade shadows out

		//move to quadrant
		worldposition.xy *= 0.5;
		worldposition.xy += 0.5;

		if (shadowMult > 0.0) 
		{

			float diffthresh = dist * 1.0f + 0.10f;
				  diffthresh *= 2.0f / (shadowMapResolution / 2048.0f);
				  //diffthresh /= shadingStruct.direct + 0.1f;






				float vpsSpread = 0.105 / distortFactor;

				float avgDepth = 0.0;
				float minDepth = 11.0;
				int c;

				for (int i = -1; i <= 1; i++)
				{
					for (int j = -1; j <= 1; j++)
					{
						vec2 lookupCoord = worldposition.xy + (vec2(i, j) / shadowMapResolution) * 8.0 * vpsSpread;
						//avgDepth += pow(texture2DLod(shadowtex1, lookupCoord, 2).x, 4.1);
						float depthSample = texture2DLod(shadowtex1, lookupCoord, 2).x;
						minDepth = min(minDepth, depthSample);
						avgDepth += pow(min(max(0.0, worldposition.z - depthSample) * 1.0, 0.025), 2.0);
						c++;
					}
				}

				avgDepth /= c;
				avgDepth = pow(avgDepth, 1.0 / 2.0);

				// float penumbraSize = min(abs(worldposition.z - minDepth), 0.15);
				float penumbraSize = avgDepth;

				//if (mask.leaves > 0.5)
				//{
					//penumbraSize = 0.02;
				//}

				int count = 0;
				float spread = penumbraSize * 0.075 * vpsSpread + 0.75 / shadowMapResolution;


				vec3 noise = BlueNoiseTemporal(texcoord.st);

				diffthresh *= 0.5 + avgDepth * 50.0;

				for (float i = -1.0f; i <= 1.0f; i += 1.0f) 
				{
					for (float j = -1.0f; j <= 1.0f; j += 1.0f) 
					{
						float angle = noise.x * 3.14159 * 2.0;

						mat2 rot = mat2(cos(angle), -sin(angle), sin(angle), cos(angle));

						vec2 coord = vec2(i + noise.y - 0.5, j + noise.y - 0.5) * rot;

						shading += shadow2DLod(shadowtex0, vec3(worldposition.st + coord * spread, worldposition.z - 0.0012f * diffthresh - (noise.z * 0.0001)), 0).x;
						count += 1;
					}
				}
				shading /= count;


		}

		vec3 result = vec3(shading);


		result = mix(vec3(1.0), result, shadowMult);

		return result;
	//} else {
	//	return vec3(0.0f);
	//}
}





float ScreenSpaceShadow(vec3 origin, vec3 normal, MaterialMask mask)
{
	if (mask.sky > 0.5 || rainStrength >= 0.999)
	{
		return 1.0;
	}

	if (isEyeInWater > 0.5)
	{
		origin.xy /= 0.82;
	}

	vec3 viewDir = normalize(origin.xyz);


	float nearCutoff = 0.50;
	float traceBias = 0.015;


	//Prevent self-intersection issues
	float viewDirDiff = dot(fwidth(viewDir), vec3(0.333333));


	vec3 rayPos = origin;
	vec3 rayDir = lightVector * 0.01;
	rayDir *= viewDirDiff * 2000.001;
	rayDir *= -origin.z * 0.28 + nearCutoff;


	rayPos += rayDir * -origin.z * 0.000017 * traceBias;



	float randomness = rand(texcoord.st + sin(frameTimeCounter)).x;

	rayPos += rayDir * randomness;



	float zThickness = 0.025 * -origin.z;

	float shadow = 1.0;

	float numSamplesf = 64.0;
	//numSamplesf /= -origin.z * 0.125 + nearCutoff;

	int numSamples = int(numSamplesf);


	float shadowStrength = 0.9;

	if (mask.grass > 0.5)
	{
		shadowStrength = 0.6;
	}
	if (mask.leaves > 0.5)
	{
		shadowStrength = 0.4;
	}

	// shadowStrength = pow(shadowStrength, exp2(-length(origin) * 0.05));

	// vec3 prevRayProjPos = ProjectBack(rayPos);

	for (int i = 0; i < 6; i++)
	{
		float fi = float(i) / float(12);

		rayPos += rayDir;

		vec2 rayProjPos = ProjectBack(rayPos).xy;


		TemporalJitterProjPos01(rayProjPos);




		// vec2 pixelPos = floor(rayProjPos.xy * vec2(viewWidth, viewHeight));
		// vec2 pixelPosPrev = floor(prevRayProjPos.xy * vec2(viewWidth, viewHeight));
		// if (pixelPos.x == pixelPosPrev.x || pixelPos.y == pixelPosPrev.y)
		// {
		// 	continue;
		// }

		// prevRayProjPos = rayProjPos;

		/*
		float sampleDepth = GetDepthLinear(rayProjPos.xy);

		float depthDiff = -rayPos.z - sampleDepth;
		*/

		vec3 samplePos = GetViewPositionNoJitter(rayProjPos.xy, GetDepth(rayProjPos.xy)).xyz;

		float depthDiff = samplePos.z - rayPos.z - 0.02 * -origin.z * traceBias;

		if (depthDiff > 0.0 && depthDiff < zThickness)
		{
			shadow *= 1.0 - shadowStrength;
		}
	}

	return shadow;
}


float OrenNayar(vec3 normal, vec3 eyeDir, vec3 lightDir)
{
	const float PI = 3.14159;
	const float roughness = 0.55;

	// interpolating normals will change the length of the normal, so renormalize the normal.



	// normal = normalize(normal + surface.lightVector * pow(clamp(dot(eyeDir, surface.lightVector), 0.0, 1.0), 5.0) * 0.5);

	// normal = normalize(normal + eyeDir * clamp(dot(normal, eyeDir), 0.0f, 1.0f));

	// calculate intermediary values
	float NdotL = dot(normal, lightDir);
	float NdotV = dot(normal, eyeDir);

	float angleVN = acos(NdotV);
	float angleLN = acos(NdotL);

	float alpha = max(angleVN, angleLN);
	float beta = min(angleVN, angleLN);
	float gamma = dot(eyeDir - normal * dot(eyeDir, normal), lightDir - normal * dot(lightDir, normal));

	float roughnessSquared = roughness * roughness;

	// calculate A and B
	float A = 1.0 - 0.5 * (roughnessSquared / (roughnessSquared + 0.57));

	float B = 0.45 * (roughnessSquared / (roughnessSquared + 0.09));

	float C = sin(alpha) * tan(beta);

	// put it all together
	float L1 = max(0.0, NdotL) * (A + B * max(0.0, gamma) * C);

	//return max(0.0f, surface.NdotL * 0.99f + 0.01f);
	return clamp(L1, 0.0f, 1.0f);
}





float GetCoverage(in float coverage, in float density, in float clouds)
{
	clouds = clamp(clouds - (1.0f - coverage), 0.0f, 1.0f -density) / (1.0f - density);
		clouds = max(0.0f, clouds * 1.1f - 0.1f);
	 clouds = clouds = clouds * clouds * (3.0f - 2.0f * clouds);
	 // clouds = pow(clouds, 1.0f);
	return clouds;
}

float   CalculateSunglow(vec3 npos, vec3 lightVector) {

	float curve = 4.0f;

	vec3 halfVector2 = normalize(-lightVector + npos);
	float factor = 1.0f - dot(halfVector2, npos);

	return factor * factor * factor * factor;
}

vec4 CloudColor(in vec4 worldPosition, in float sunglow, in vec3 worldLightVector, in float altitude, in float thickness, const bool isShadowPass)
{

	float cloudHeight = altitude;
	float cloudDepth  = thickness;
	float cloudUpperHeight = cloudHeight + (cloudDepth / 2.0f);
	float cloudLowerHeight = cloudHeight - (cloudDepth / 2.0f);

	//worldPosition.xz /= 1.0f + max(0.0f, length(worldPosition.xz - cameraPosition.xz) / 5000.0f);

	vec3 p = worldPosition.xyz / 150.0f;



	float t = frameTimeCounter * 1.0f;
		  t *= 0.5;


	 p += (Get3DNoise(p * 2.0f + vec3(0.0f, t * 0.00f, 0.0f)) * 2.0f - 1.0f) * 0.10f;
	 p.z -= (Get3DNoise(p * 0.25f + vec3(0.0f, t * 0.00f, 0.0f)) * 2.0f - 1.0f) * 0.45f;
	 p.x -= (Get3DNoise(p * 0.125f + vec3(0.0f, t * 0.00f, 0.0f)) * 2.0f - 1.0f) * 2.2f;
	p.xz -= (Get3DNoise(p * 0.0525f + vec3(0.0f, t * 0.00f, 0.0f)) * 2.0f - 1.0f) * 2.7f;


	p.x *= 0.5f;
	p.x -= t * 0.01f;

	vec3 p1 = p * vec3(1.0f, 0.5f, 1.0f)  + vec3(0.0f, t * 0.01f, 0.0f);
	float noise  = 	Get3DNoise(p * vec3(1.0f, 0.5f, 1.0f) + vec3(0.0f, t * 0.01f, 0.0f));	p *= 2.0f;	p.x -= t * 0.057f;	vec3 p2 = p;
		  noise += (2.0f - abs(Get3DNoise(p) * 2.0f - 0.0f)) * (0.15f);						p *= 3.0f;	p.xz -= t * 0.035f;	p.x *= 2.0f;	vec3 p3 = p;
		  noise += (3.0f - abs(Get3DNoise(p) * 3.0f - 0.0f)) * (0.050f);						p *= 3.0f;	p.xz -= t * 0.035f;	vec3 p4 = p;
		  noise += (3.0f - abs(Get3DNoise(p) * 3.0f - 0.0f)) * (0.015f);						p *= 3.0f;	p.xz -= t * 0.035f;
		  if (!isShadowPass)
		  {
		 		noise += ((Get3DNoise(p))) * (0.022f);												p *= 3.0f;
		  		noise += ((Get3DNoise(p))) * (0.009f);
		  }
		  noise /= 1.475f;

	//cloud edge
	float coverage = 0.701f;
		  coverage = mix(coverage, 0.97f, rainStrength);

		  float dist = length(worldPosition.xz - cameraPosition.xz * 0.5);
		  coverage *= max(0.0f, 1.0f - dist / 14000.0f);
	float density = 0.1f + rainStrength * 0.3;

	if (isShadowPass)
	{
		return vec4(GetCoverage(0.4f, 0.4f, noise));
	}

	noise = GetCoverage(coverage, density, noise);

	const float lightOffset = 0.4f;



	float sundiff = Get3DNoise(p1 + worldLightVector.xyz * lightOffset);
		  sundiff += (2.0f - abs(Get3DNoise(p2 + worldLightVector.xyz * lightOffset / 2.0f) * 2.0f - 0.0f)) * (0.55f);
		  				float largeSundiff = sundiff;
		  				      largeSundiff = -GetCoverage(coverage, 0.0f, largeSundiff * 1.3f);
		  sundiff += (3.0f - abs(Get3DNoise(p3 + worldLightVector.xyz * lightOffset / 5.0f) * 3.0f - 0.0f)) * (0.045f);
		  sundiff += (3.0f - abs(Get3DNoise(p4 + worldLightVector.xyz * lightOffset / 8.0f) * 3.0f - 0.0f)) * (0.015f);
		  sundiff /= 1.5f;

		  sundiff *= max(0.0f, 1.0f - dist / 14000.0f);

		  sundiff = -GetCoverage(coverage * 1.0f, 0.0f, sundiff);
	float secondOrder 	= pow(clamp(sundiff * 1.1f + 1.45f, 0.0f, 1.0f), 4.0f);
	float firstOrder 	= pow(clamp(largeSundiff * 1.1f + 1.66f, 0.0f, 1.0f), 3.0f);



	float directLightFalloff = firstOrder * secondOrder;
	float anisoBackFactor = mix(clamp(pow(noise, 1.6f) * 2.5f, 0.0f, 1.0f), 1.0f, pow(sunglow, 1.0f));

		  directLightFalloff *= anisoBackFactor;
	 	  directLightFalloff *= mix(11.5f, 1.0f, pow(sunglow, 0.5f));

	//noise *= saturate(1.0 - directLightFalloff);

	vec3 colorDirect = colorSunlight * 51.215f;
		 colorDirect = mix(colorDirect, colorDirect * vec3(0.2f, 0.2f, 0.2f), timeMidnight);
		 colorDirect *= 1.0f + pow(sunglow, 2.0f) * 120.0f * pow(directLightFalloff, 1.1f) * (1.0 - rainStrength * 0.8);
		 colorDirect *= 1.0f;


	vec3 colorAmbient = mix(colorSkylight, colorSunlight * 2.0f, vec3(0.15f)) * 0.93f;
		 colorAmbient = mix(colorAmbient, vec3(0.4) * Luminance(colorSkylight), vec3(rainStrength));
		 colorAmbient *= mix(1.0f, 0.3f, timeMidnight);
		 colorAmbient = mix(colorAmbient, colorAmbient * 3.0f + colorSunlight * 0.05f, vec3(clamp(pow(1.0f - noise, 12.0f) * 1.0f, 0.0f, 1.0f)));




	directLightFalloff *= mix(1.0, 0.085, rainStrength);

	//directLightFalloff += (pow(Get3DNoise(p3), 2.0f) * 0.5f + pow(Get3DNoise(p3 * 1.5f), 2.0f) * 0.25f) * 0.02f;
	//directLightFalloff *= Get3DNoise(p2);

	vec3 color = mix(colorAmbient, colorDirect, vec3(min(1.0f, directLightFalloff)));

	color *= 1.0f;

	color = mix(color, color * 0.9, rainStrength);


	vec4 result = vec4(color.rgb, noise);

	return result;

}

void CloudPlane(inout vec3 color, vec3 viewDir, vec3 worldVector, float linearDepth, MaterialMask mask, vec3 worldLightVector, vec3 lightVector)
{
	//Initialize view ray
	//vec4 worldVector = gbufferModelViewInverse * (vec4(-GetScreenSpacePosition(texcoord.st).xyz, 0.0));


	Ray viewRay;

	viewRay.dir = normalize(worldVector.xyz);
	viewRay.origin = vec3(0.0f);

	float sunglow = CalculateSunglow(viewDir, lightVector);



	float cloudsAltitude = 540.0f;
	float cloudsThickness = 150.0f;

	float cloudsUpperLimit = cloudsAltitude + cloudsThickness * 0.5f;
	float cloudsLowerLimit = cloudsAltitude - cloudsThickness * 0.5f;

	float density = 1.0f;

	float planeHeight = cloudsUpperLimit;
	float stepSize = 25.5f;
	planeHeight -= cloudsThickness * 0.85f;


	Plane pl;
	pl.origin = vec3(0.0f, cameraPosition.y - planeHeight, 0.0f);
	pl.normal = vec3(0.0f, 1.0f, 0.0f);

	Intersection i = RayPlaneIntersectionWorld(viewRay, pl);

	vec3 original = color.rgb;

	if (i.angle < 0.0f)
	{
		if (i.distance < linearDepth || mask.sky > 0.5 || linearDepth >= far - 0.1)
		{
			vec4 cloudSample = CloudColor(vec4(i.pos.xyz * 0.5f + vec3(30.0f) + vec3(1000.0, 0.0, 0.0), 1.0f), sunglow, worldLightVector, cloudsAltitude, cloudsThickness, false);
			 	 cloudSample.a = min(1.0f, cloudSample.a * density);


			float cloudDist = length(i.pos.xyz - cameraPosition.xyz);

			const vec3 absorption = vec3(0.2, 0.4, 1.0);

			cloudSample.rgb *= exp(-cloudDist * absorption * 0.0001 * saturate(1.0 - sunglow * 2.0) * (1.0 - rainStrength));

			cloudSample.a *= exp(-cloudDist * (0.0002 + rainStrength * 0.0009));


			//cloudSample.rgb *= sin(cloudDist * 0.3) * 0.5 + 0.5;

			color.rgb = mix(color.rgb, cloudSample.rgb * 1.0f, cloudSample.a);

		}
	}
}


float G1V(float dotNV, float k)
{
	return 1.0 / (dotNV * (1.0 - k) + k);
}

vec3 SpecularGGX(vec3 N, vec3 V, vec3 L, float roughness, float F0)
{
	float alpha = roughness * roughness;

	vec3 H = normalize(V + L);

	float dotNL = saturate(dot(N, L));
	float dotNV = saturate(dot(N, V));
	float dotNH = saturate(dot(N, H));
	float dotLH = saturate(dot(L, H));

	float F, D, vis;

	float alphaSqr = alpha * alpha;
	float pi = 3.14159265359;
	float denom = dotNH * dotNH * (alphaSqr - 1.0) + 1.0;
	D = alphaSqr / (pi * denom * denom);

	float dotLH5 = pow(1.0f - dotLH, 5.0);
	F = F0 + (1.0 - F0) * dotLH5;

	float k = alpha / 2.0;
	vis = G1V(dotNL, k) * G1V(dotNV, k);

	vec3 specular = vec3(dotNL * D * F * vis) * colorSunlight;

	//specular = vec3(0.1);
	#ifndef PHYSICALLY_BASED_MAX_ROUGHNESS
	specular *= saturate(pow(1.0 - roughness, 0.7) * 2.0);
	#endif


	return specular;
}






























int t(float v)
 {
   return int(floor(v));
 }
 int f(int v)
 {
   return v-t(mod(float(v),2.))-0;
 }
 int d(int v)
 {
   return v-t(mod(float(v),2.))-1;
 }
 int d()
 {
   ivec2 v=ivec2(viewWidth,viewHeight);
   int z=v.x*v.y;
   return f(t(floor(pow(float(z),.333333))));
 }
 int f()
 {
   ivec2 v=ivec2(2048,2048);
   int f=v.x*v.y;
   return d(t(floor(pow(float(f),.333333))));
 }
 vec3 v(vec2 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int z=f.x*f.y,y=d();
   ivec2 n=ivec2(v.x*f.x,v.y*f.y);
   float x=float(n.y/y),r=float(int(n.x+mod(f.x*x,y))/y);
   r+=floor(f.x*x/y);
   vec3 i=vec3(0.,0.,r);
   i.x=mod(n.x+mod(f.x*x,y),y);
   i.y=mod(n.y,y);
   i.xyz=floor(i.xyz);
   i/=y;
   i.xyz=i.xzy;
   return i;
 }
 vec2 s(vec3 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int z=d();
   vec3 i=v.xzy*z;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 r;
   r.x=mod(i.x+x*z,f.x);
   float s=i.x+x*z;
   r.y=i.y+floor(s/f.x)*z;
   r+=.5;
   r/=f;
   return r;
 }
 vec3 e(vec2 v)
 {
   vec2 i=v;
   i.xy/=.5;
   ivec2 n=ivec2(2048,2048);
   int z=n.x*n.y,y=f();
   ivec2 d=ivec2(i.x*n.x,i.y*n.y);
   float x=float(d.y/y),r=float(int(d.x+mod(n.x*x,y))/y);
   r+=floor(n.x*x/y);
   vec3 s=vec3(0.,0.,r);
   s.x=mod(d.x+mod(n.x*x,y),y);
   s.y=mod(d.y,y);
   s.xyz=floor(s.xyz);
   s/=y;
   s.xyz=s.xzy;
   return s;
 }
 vec2 d(vec3 v,int z)
 {
   v=clamp(v,vec3(0.),vec3(1.));
   ivec2 f=ivec2(2048,2048);
   vec3 i=v.xzy*z;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 r;
   r.x=mod(i.x+x*z,f.x);
   float s=i.x+x*z;
   r.y=i.y+floor(s/f.x)*z;
   r+=.5;
   r/=f;
   r.xy*=.5;
   return r;
 }
 vec3 e(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v=clamp(v,vec3(0.),vec3(1.)),v;
 }
 vec3 f(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v;
 }
 vec3 i(vec3 v)
 {
   int z=f();
   v=v-vec3(.5);
   v*=z;
   return v;
 }
 vec3 m(vec3 v)
 {
   int z=d();
   v*=1./z;
   v=v+vec3(.5);
   v=clamp(v,vec3(0.),vec3(1.));
   return v;
 }
 vec3 r(vec3 v)
 {
   int z=d();
   v=v-vec3(.5);
   v*=z;
   return v;
 }
 vec3 n(vec3 v)
 {
   vec4 f=vec4(v,1.);
   f.xyz+=1.;
   f.xyz-=Fract01(cameraPosition.xyz+.5);
   f=shadowModelView*f;
   f=shadowProjection*f;
   f/=f.w;
   float x=sqrt(f.x*f.x+f.y*f.y),y=1.f-SHADOW_MAP_BIAS+x*SHADOW_MAP_BIAS;
   f.xy*=.95f/y;
   f.z=mix(f.z,.5,.8);
   f=f*.5f+.5f;
   f.xy*=.5;
   f.xy+=.5;
   return f.xyz;
 }struct zNBzKgUtly{float AvJUxmdirG;float WCbWyvymZz;float ABrGOYvmhP;float dyVwWpTUTv;vec3 kVdfXZomUb;};
 vec4 w(zNBzKgUtly v)
 {
   vec4 f;
   v.kVdfXZomUb=max(vec3(0.),v.kVdfXZomUb);
   f.x=v.AvJUxmdirG;
   v.kVdfXZomUb=pow(v.kVdfXZomUb,vec3(.25));
   f.y=PackTwo16BitTo32Bit(v.kVdfXZomUb.x,v.ABrGOYvmhP);
   f.z=PackTwo16BitTo32Bit(v.kVdfXZomUb.y,v.dyVwWpTUTv);
   f.w=PackTwo16BitTo32Bit(v.kVdfXZomUb.z,v.WCbWyvymZz);
   return f;
 }
 zNBzKgUtly x(vec4 v)
 {
   zNBzKgUtly f;
   vec2 i=UnpackTwo16BitFrom32Bit(v.y),n=UnpackTwo16BitFrom32Bit(v.z),s=UnpackTwo16BitFrom32Bit(v.w);
   f.AvJUxmdirG=v.x;
   f.ABrGOYvmhP=i.y;
   f.dyVwWpTUTv=n.y;
   f.WCbWyvymZz=s.y;
   f.kVdfXZomUb=pow(vec3(i.x,n.x,s.x),vec3(4.));
   return f;
 }
 zNBzKgUtly p(vec2 v)
 {
   vec2 z=1./vec2(viewWidth,viewHeight),y=vec2(viewWidth,viewHeight);
   v=(floor(v*y)+.5)*z;
   return x(texture2DLod(colortex5,v,0));
 }
 float i(float v,float y)
 {
   float z=1.;
   #ifdef FULL_RT_REFLECTIONS
   z=clamp(pow(v,.125)+y,0.,1.);
   #else
   z=clamp(v*10.-7.,0.,1.);
   #endif
   return z;
 }
 void d(inout float v,inout float f,float x,float y,vec3 i,float z)
 {
   v*=mix(2.,2.4,y);
   float s=dot(i,vec3(1.));
   f*=1.-pow(y,1.);
   f/=x*.1+2e-06;
   f*=4.;
   f*=.1;
   float r=x/(s+1e-07)*.2+4e-08;
   r=min(r,1.);
   r=mix(r,1.,pow(y,.25));
   if(z<.12)
     f=0.;
 }
 float d(vec3 v,vec3 y,float f)
 {
   float z=dot(abs(v-y),vec3(.3333));
   z*=f;
   z*=.18;
   return z;
 }
 void e(inout vec3 v,vec2 z,vec3 y)
 {}
 float m(float v,float f)
 {
   return v/(f*20.01+1.);
 }struct BBRay{vec3 origin;vec3 direction;vec3 inv_direction;ivec3 sign;};
 BBRay n(vec3 v,vec3 y)
 {
   vec3 f=vec3(1.)/y;
   return BBRay(v,y,f,ivec3(f.x<0?1:0,f.y<0?1:0,f.z<0?1:0));
 }
 void d(in BBRay v,in vec3 f[2],out float i,out float r)
 {
   float y,z,x,s;
   i=(f[v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   r=(f[1-v.sign[0]].x-v.origin.x)*v.inv_direction.x;
   y=(f[v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   z=(f[1-v.sign[1]].y-v.origin.y)*v.inv_direction.y;
   x=(f[v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   s=(f[1-v.sign[2]].z-v.origin.z)*v.inv_direction.z;
   i=max(max(i,y),x);
   r=min(min(r,z),s);
 }
 vec2 h(inout float v)
 {
   return fract(sin(vec2(v+=.1,v+=.1))*vec2(43758.5,22578.1));
 }
 vec3 f(vec3 v,inout float y,int z)
 {
   vec2 f=BlueNoiseTemporal(texcoord.xy+vec2(y+=.1,y+=.1)).xy;
   f=fract(f+h(y)*.1);
   float i=6.28319*f.x,x=sqrt(f.y);
   vec3 s=normalize(cross(v,vec3(0.,1.,1.))),w=cross(v,s),r=s*cos(i)*x+w*sin(i)*x+v.xyz*sqrt(1.-f.y);
   return r;
 }
 float e(vec3 v,vec3 y,vec3 z,int f)
 {
   vec3 x=i(v),s=n(x+y*.99);
   float r=.5,w=shadow2DLod(shadowtex0,vec3(s.xy,s.z-.0006*r),3).x;
   w*=saturate(dot(worldLightVector,y));
   return w;
 }
 float f(vec3 v,vec3 y,vec3 z,int f)
 {
   vec3 i=n(v);
   float x=.5,r=shadow2DLod(shadowtex0,vec3(i.xy,i.z-.0006*x),2).x;
   r*=saturate(dot(worldLightVector,y));
   return r;
 }
 vec3 e()
 {
   vec3 v=cameraPosition.xyz+.5-Fract01(cameraPosition.xyz+.5),y=previousCameraPosition+.5-Fract01(previousCameraPosition+.5);
   return v-y;
 }
 vec3 h(vec3 v,vec3 y)
 {
   vec2 f=s(m(i(v)+y+1.));
   vec3 z=p(f).kVdfXZomUb;
   return z;
 }
 vec3 h()
 {
   vec2 f=s(v(texcoord.xy)+e()/d());
   vec3 z=p(f).kVdfXZomUb;
   return z;
 }
 vec3 h(float v,float z,float f,vec3 y)
 {
   vec3 i;
   i.x=f*cos(v);
   i.y=f*sin(v);
   i.z=z;
   vec3 x=abs(y.y)<.999?vec3(0,0,1):vec3(1,0,0),r=normalize(cross(y,vec3(0.,1.,1.))),w=cross(r,y);
   return r*i.x+w*i.y+y*i.z;
 }
 vec3 h(vec2 v,float f,vec3 y)
 {
   float z=2*3.14159*v.x,x=sqrt((1-v.y)/(1+(f*f-1)*v.y)),r=sqrt(1-x*x);
   return h(z,x,r,y);
 }
 float c(float v)
 {
   return 2./(v*v+1e-07)-2.;
 }
 vec3 c(in vec2 v,in float y,in vec3 f)
 {
   float z=c(y),i=2*3.14159*v.x,x=pow(v.y,1.f/(z+1.f)),r=sqrt(1-x*x);
   return h(i,x,r,f);
 }
 vec3 l(vec3 v)
 {
   float z=fract(frameCounter*.0123456);
   int y=f(),i=d();
   vec3 x=BlueNoiseTemporal(texcoord.xy).xyz,s=BlueNoiseTemporal(texcoord.xy+.1).xyz,r=v,w=Fract01(cameraPosition.xyz+.5)+vec3(0.,1.7,0.),b=w;
   w=e(w,y);
   Ray o;
   o.origin=w*y-vec3(1.,1.,1.);
   o.dir=r;
   BBRay t=n(o.origin,o.dir);
   vec3 m=vec3(1.),B=vec3(0.);
   for(int c=0;c<1;c++)
     {
       vec3 p=vec3(floor(o.origin)),G=abs(vec3(length(o.dir))/(o.dir+.0001)),Y=sign(o.dir),l=(sign(o.dir)*(p-o.origin)+sign(o.dir)*.5+.5)*G,a;
       vec4 g=vec4(0.);
       vec3 S=vec3(0.);
       float k=.5;
       for(int A=0;A<190;A++)
         {
           S=p/float(y);
           vec2 W=d(S,y);
           g=texture2DLod(shadowcolor,W,0);
           if(abs(g.w*255.-130.)<.5)
             B+=.06125*m*colorTorchlight*k;
           else
             {
               if(g.w*255.<254.f&&A!=0)
                 {
                   break;
                 }
             }
           a=step(l.xyz,l.yzx)*step(l.xyz,l.zxy);
           l+=a*G;
           p+=a*Y;
           k=1.;
         }
       if(g.w*255.<1.f||g.w*255.>254.f)
         {
           vec3 A=max(vec3(0.),AtmosphericScattering(o.dir,worldSunVector,0.));
           A+=pow(saturate(dot(o.dir,worldLightVector)),5.)*colorSunlight*7.;
           A*=m;
           A*=saturate(dot(o.dir,vec3(0.,1.,0.))*100.)*.9+.1;
           B+=A*.1;
           break;
         }
       if(g.w*255.>1.f&&g.w*255.<128.f)
         {
           vec3 A=saturate(g.xyz);
           m*=A;
         }
       if(g.w*255.>131.&&g.w*255.<137.)
         B+=.5*m*normalize(g.xyz+.0001);
       if(abs(g.w*255.-141.)<.5)
         B=vec3(0.,0.,0.);
       vec3 A=-(a*Y),W[2]=vec3[2](p,p+1.);
       float L,P;
       d(t,W,L,P);
       vec3 F=(o.origin+o.dir*L)/float(y),R=vec3(1.)-abs(A);
       B+=h(S+(s.xyz-.5)/float(y)*2.*R,A)*m;
       const float u=2.4;
       B+=.5*m;
     }
   B*=1.;
   return B;
 }
 vec3 c(vec3 v,vec3 y)
 {
   v+=Fract01(cameraPosition.xyz+.5)-.5;
   vec3 f=m(v+y*.1),z=p(s(f)).kVdfXZomUb;
   return z;
 }
 vec3 c(vec2 v,vec3 z,float f,vec3 y)
 {
   vec3 x=texture2DLod(colortex6,v,0).xyz;
   return x;
 }
 void main()
 {
   GBufferData v=GetGBufferData();
   MaterialMask f=CalculateMasks(v.materialID);
   vec4 i=GetViewPosition(texcoord.xy,v.depth),y=gbufferModelViewInverse*vec4(i.xyz,1.),s=gbufferModelViewInverse*vec4(i.xyz,0.);
   vec3 z=normalize(i.xyz),r=normalize(s.xyz),x=normalize((gbufferModelViewInverse*vec4(v.normal,0.)).xyz);
   float w=length(i.xyz);
   vec3 n=vec3(0.);
   if(f.grass>.5)
     x=vec3(0.,1.,0.);
   vec3 m=c(texcoord.xy,v.normal,v.depth,i.xyz)*10.,p=m*v.albedo.xyz;
   const float t=75.;
   if(w>t)
     {
       vec3 A=FromSH(skySHR,skySHG,skySHB,x);
       A=mix(A,vec3(.2)*(dot(x,vec3(0.,1.,0.))*.35+.65)*Luminance(colorSkylight),vec3(rainStrength));
       A*=v.mcLightmap.y;
       vec3 B=A*v.albedo.xyz*3.5;
       const float G=3.7;
       B+=v.mcLightmap.x*colorTorchlight*v.albedo.xyz*.025*G;
       float d=1./(pow(length(y.xyz),2.)+.5);
       vec3 a=normalize(v.albedo.xyz+.0001)*pow(length(v.albedo.xyz),1.)*colorSunlight*.13*v.mcLightmap.y;
       B+=a*v.albedo.xyz*10.;
       float e=.3;
       p=mix(p,B,vec3(saturate(w*e-t*e)));
     }
   n.xyz=p;
   float A=24.*(1.-rainStrength),l=dot(x,worldLightVector),o=OrenNayar(x,-r,worldLightVector);
   if(f.leaves>.5)
     o=mix(o,.5,.5);
   if(f.grass>.5)
     v.metalness=0.;
   vec3 B=CalculateSunlightVisibility(i,f);
   #ifdef SUNLIGHT_LEAK_FIX
   float d=saturate(v.mcLightmap.y*100.);
   B*=d;
   #endif
   if(isEyeInWater<1)
     B*=ScreenSpaceShadow(i.xyz,v.normal.xyz,f);
   n+=DoNightEyeAtNight(o*v.albedo.xyz*B*A*colorSunlight,timeMidnight);
   vec3 g=SpecularGGX(x,-r,worldLightVector,1.-v.smoothness,v.metalness*.98+.02)*A*B;
   g*=mix(vec3(1.),v.albedo.xyz,vec3(v.metalness));
   if(isEyeInWater<.5)
     n*=1.-v.metalness,n+=DoNightEyeAtNight(g,timeMidnight);
   if(f.sky>.5||v.depth>1.)
     {
       n=SkyShading(r.xyz,worldSunVector.xyz,rainStrength);
       vec3 G=AtmosphereAbsorption(r.xyz);
       n+=v.albedo.xyz*G*.5;
       n+=RenderSunDisc(r,worldSunVector)*G*2000.*(1.-rainStrength);
       CloudPlane(n,z,-r,w,f,worldLightVector,lightVector);
     }
   if(f.glowstone>.5)
     n.xyz+=v.albedo.xyz*GI_LIGHT_BLOCK_INTENSITY;
   if(f.torch>.5)
     n.xyz+=v.albedo.xyz*pow(length(v.albedo.xyz),2.)*.5*GI_LIGHT_TORCH_INTENSITY;
   if(f.lava>.5)
     n+=v.albedo.xyz*2.*GI_LIGHT_BLOCK_INTENSITY;
   if(f.fire>.5)
     n+=v.albedo.xyz*3.*GI_LIGHT_TORCH_INTENSITY;
   n*=.001;
   n=LinearToGamma(n);
   n+=rand(texcoord.xy+sin(frameTimeCounter))*(1./65535.);
   gl_FragData[0]=vec4(n.xyz,1.);
 };

/* DRAWBUFFERS:3 */
