#version 330 compatibility
#extension GL_ARB_shading_language_packing : enable
#extension GL_ARB_shader_bit_encoding : enable


#include "lib/Uniforms.inc"
#include "lib/Common.inc"









uniform sampler2D tex;

in vec4 texcoord;
in vec4 color;
in vec3 normal;
in vec3 rawNormal;
in vec4 viewPos;

in float materialIDs;
in float mcEntity;

in vec4 lmcoord;

in float invalid;
in float DCPUZWJAWq;
in float nqbOYzWFJP;
in float sVqcfOoSrb;

in vec2 vFsmmLxuUQ;

// #define FULL_RT_REFLECTIONS // OFF: only surfaces with high smoothness values will render reflections. ON: Allow rougher surfaces to render reflections (higher computational cost). This can cause big slowdowns with lots of semi-rough surfaces!
#define REFLECTION_TRACE_LENGTH 90 // The maximum ray length of ray traced reflections. Higher values result in reflections tracing farther into the world at a higher cost. Lower values can can cause leaking in large indoor areas! [60 90 120 150]
#define DIFFUSE_TRACE_LENGTH 60 // The maximum ray length of path traced diffuse GI. Higher values result in more accurate lighting, taking farther away surfaces into account, at a higher cost. Lower values can cause leaking in large indoor areas! [60 80 100 120]
#define GI_RESPONSIVENESS 3 // How well GI responds to lighting changes over time. Lower settings sacrifice responsiveness for improved stability, better noise reduction, and higher detail in GI. [0 1 2 3]
// #define GI_SCREEN_SPACE_TRACING // Allows for surfaces in screen-space to cast indirect shadows and lighting that wouldn't otherwise (mobs, grass, etc.). If enabled, can leave weird ghosty shadows when GI Responsiveness is low.
#define GI_FILTER_QUALITY 1 // Quality of GI filter. [0 1]
// #define REFLECTION_SCREEN_SPACE_TRACING // Allows for surfaces in screen-space to show up in reflections that wouldn't othwerise (mobs, grass, etc.). 
#define GI_SECONDARY_SAMPLES 1 // How many samples to trace for the secondary GI tracing. Higher samples reduces the "disco floor" artifact mostly seen in reflections at the cost of performance. [1 2 3 4]

#define GI_LIGHT_BLOCK_INTENSITY 1.0 // How bright light from solid blocks is. [0.2 0.4 0.6 0.8 1.0 1.5 2.0 2.5 3.0 4.0 5.0 7.0 10.0]
#define GI_LIGHT_TORCH_INTENSITY 1.0 // How bright light from torches is. [0.2 0.4 0.6 0.8 1.0 1.5 2.0 2.5 3.0 4.0 5.0 7.0 10.0]


// #define GI_SIMPLE_SKY_TERM // Off: Provides true ambient GI light color from sky. On: Uses a simpler less-accurate sky term for GI for better performance













// GI volume material IDs
#define GI_ID_BLOCK_SOLID 30.0
#define GI_ID_BLOCK_LIGHT 31.0
#define GI_ID_BLOCK_LEAVES 32.0
#define GI_ID_BLOCK_ICE 33.0

#define GI_ID_FIRST_NONSOLID 240.0

#define GI_ID_BLOCK_ABSORB 240.0
#define GI_ID_NONBLOCK_LIGHT 241.0




#define GI_NONBLOCK_LIGHT_BRIGHTNESS 1.0



int v(float v)
 {
   return int(floor(v));
 }
 int t(int f)
 {
   return f-v(mod(float(f),2.))-0;
 }
 int d(int f)
 {
   return f-v(mod(float(f),2.))-1;
 }
 int d()
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int z=f.x*f.y;
   return t(v(floor(pow(float(z),.333333))));
 }
 int t()
 {
   ivec2 f=ivec2(2048,2048);
   int z=f.x*f.y;
   return d(v(floor(pow(float(z),.333333))));
 }
 vec3 r(vec2 v)
 {
   ivec2 f=ivec2(viewWidth,viewHeight);
   int z=f.x*f.y,y=d();
   ivec2 i=ivec2(v.x*f.x,v.y*f.y);
   float x=float(i.y/y),r=float(int(i.x+mod(f.x*x,y))/y);
   r+=floor(f.x*x/y);
   vec3 m=vec3(0.,0.,r);
   m.x=mod(i.x+mod(f.x*x,y),y);
   m.y=mod(i.y,y);
   m.xyz=floor(m.xyz);
   m/=y;
   m.xyz=m.xzy;
   return m;
 }
 vec2 f(vec3 f)
 {
   ivec2 v=ivec2(viewWidth,viewHeight);
   int z=d();
   vec3 i=f.xzy*z;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 r;
   r.x=mod(i.x+x*z,v.x);
   float m=i.x+x*z;
   r.y=i.y+floor(m/v.x)*z;
   r+=.5;
   r/=v;
   return r;
 }
 vec3 w(vec2 f)
 {
   vec2 v=f;
   v.xy/=.5;
   ivec2 i=ivec2(2048,2048);
   int z=i.x*i.y,y=t();
   ivec2 m=ivec2(v.x*i.x,v.y*i.y);
   float x=float(m.y/y),r=float(int(m.x+mod(i.x*x,y))/y);
   r+=floor(i.x*x/y);
   vec3 c=vec3(0.,0.,r);
   c.x=mod(m.x+mod(i.x*x,y),y);
   c.y=mod(m.y,y);
   c.xyz=floor(c.xyz);
   c/=y;
   c.xyz=c.xzy;
   return c;
 }
 vec2 d(vec3 f,int y)
 {
   f=clamp(f,vec3(0.),vec3(1.));
   ivec2 v=ivec2(2048,2048);
   vec3 i=f.xzy*y;
   i=floor(i+1e-05);
   float x=i.z;
   vec2 r;
   r.x=mod(i.x+x*y,v.x);
   float z=i.x+x*y;
   r.y=i.y+floor(z/v.x)*y;
   r+=.5;
   r/=v;
   r.xy*=.5;
   return r;
 }
 vec3 f(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v=clamp(v,vec3(0.),vec3(1.)),v;
 }
 vec3 r(vec3 v,int y)
 {
   return v*=1./y,v=v+vec3(.5),v;
 }
 vec3 s(vec3 f)
 {
   int v=t();
   f=f-vec3(.5);
   f*=v;
   return f;
 }
 vec3 p(vec3 v)
 {
   int z=d();
   v*=1./z;
   v=v+vec3(.5);
   v=clamp(v,vec3(0.),vec3(1.));
   return v;
 }
 vec3 x(vec3 v)
 {
   int f=d();
   v=v-vec3(.5);
   v*=f;
   return v;
 }
 vec3 n(vec3 v)
 {
   vec4 f=vec4(v,1.);
   f.xyz+=1.;
   f.xyz-=Fract01(cameraPosition.xyz+.5);
   f=shadowModelView*f;
   f=shadowProjection*f;
   f/=f.w;
   float x=sqrt(f.x*f.x+f.y*f.y),y=1.f-SHADOW_MAP_BIAS+x*SHADOW_MAP_BIAS;
   f.xy*=.95f/y;
   f.z=mix(f.z,.5,.8);
   f=f*.5f+.5f;
   f.xy*=.5;
   f.xy+=.5;
   return f.xyz;
 }struct zNBzKgUtly{float AvJUxmdirG;float WCbWyvymZz;float ABrGOYvmhP;float dyVwWpTUTv;vec3 kVdfXZomUb;};
 vec4 A(zNBzKgUtly v)
 {
   vec4 f;
   v.kVdfXZomUb=max(vec3(0.),v.kVdfXZomUb);
   f.x=v.AvJUxmdirG;
   v.kVdfXZomUb=pow(v.kVdfXZomUb,vec3(.25));
   f.y=PackTwo16BitTo32Bit(v.kVdfXZomUb.x,v.ABrGOYvmhP);
   f.z=PackTwo16BitTo32Bit(v.kVdfXZomUb.y,v.dyVwWpTUTv);
   f.w=PackTwo16BitTo32Bit(v.kVdfXZomUb.z,v.WCbWyvymZz);
   return f;
 }
 zNBzKgUtly i(vec4 f)
 {
   zNBzKgUtly v;
   vec2 i=UnpackTwo16BitFrom32Bit(f.y),m=UnpackTwo16BitFrom32Bit(f.z),y=UnpackTwo16BitFrom32Bit(f.w);
   v.AvJUxmdirG=f.x;
   v.ABrGOYvmhP=i.y;
   v.dyVwWpTUTv=m.y;
   v.WCbWyvymZz=y.y;
   v.kVdfXZomUb=pow(vec3(i.x,m.x,y.x),vec3(4.));
   return v;
 }
 zNBzKgUtly m(vec2 v)
 {
   vec2 f=1./vec2(viewWidth,viewHeight),y=vec2(viewWidth,viewHeight);
   v=(floor(v*y)+.5)*f;
   return i(texture2DLod(colortex5,v,0));
 }
 float A(float v,float y)
 {
   float f=1.;
   #ifdef FULL_RT_REFLECTIONS
   f=clamp(pow(v,.125)+y,0.,1.);
   #else
   f=clamp(v*10.-7.,0.,1.);
   #endif
   return f;
 }
 void A(inout float v,inout float f,float x,float y,vec3 i,float z)
 {
   v*=mix(2.,2.4,y);
   float m=dot(i,vec3(1.));
   f*=1.-pow(y,1.);
   f/=x*.1+2e-06;
   f*=4.;
   f*=.1;
   float r=x/(m+1e-07)*.2+4e-08;
   r=min(r,1.);
   r=mix(r,1.,pow(y,.25));
   if(z<.12)
     f=0.;
 }
 float A(vec3 v,vec3 y,float f)
 {
   float r=dot(abs(v-y),vec3(.3333));
   r*=f;
   r*=.18;
   return r;
 }
 void d(inout vec3 v,vec2 f,vec3 y)
 {}
 float i(float v,float f)
 {
   return v/(f*20.01+1.);
 }
 void main()
 {
   if(invalid>.5||sVqcfOoSrb>.5)
     {
       discard;
     }
   vec4 v=texture2D(tex,texcoord.xy,0);
   vec3 f=v.xyz*color.xyz;
   float y=1.;
   if(DCPUZWJAWq<.5)
     y=min(v.w*10.,1.),gl_FragDepth=gl_FragCoord.z;
   else
      gl_FragDepth=nqbOYzWFJP;
   vec3 z=normal.xyz;
   f*=f;
   if(abs(mcEntity-50.)<.1)
     f.xyz=GetColorTorchlight()*.1*GI_LIGHT_TORCH_INTENSITY;
   if(abs(mcEntity-76.)<.1)
     f.xyz=vec3(1.,.02,.01)*.05*GI_LIGHT_TORCH_INTENSITY;
   if(abs(mcEntity-51.)<.1)
     f.xyz=vec3(1.,.35,.05)*.5;
   float x=clamp((abs(color.x-color.y)+abs(color.x-color.z)+abs(color.y-color.z))*500.,0.,1.);
   gl_FragData[0]=vec4(f.xyz,(materialIDs+.1)/255.*y);
   gl_FragData[1]=vec4(vFsmmLxuUQ.xy,x,dot(v.xyz,vec3(.33333)));
 };
